
// *****************************************************************************
//
// source:    AC_ECAL_init.C
//
// type:      source code
//
// created:   18 May 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_ECAL_init()
//
// called by: AC_init()
//
// changes:
// 18 May 2000 (AG) creation on request of S. Shuvalov
// 22 May 2000 (AG) add these comments
// 16 Sep 2000 (AG) polish printout
//
// *****************************************************************************

// ARTE includes
#include "alca/AC_ECAL.h"
#include "farm/farm.hh"

//
// program code
//
int 
AC_ECAL_init()
{
  // show up
  ARTE_mark( "AC_ECAL_init 0", 0 );
  cout << "AC_ECAL_init" << endl;

  // call ECAL init function
  AC_ECAL_ihists_initialize();

  ARTE_mark( "AC_ECAL_init 1", 0 );
  return 0;
}


