
// ****************************************************************************
//
// Routine:      acSetDateTime
// Author:       T.Oest
//
// Description:  set date and time in event header
//               
// Modification:
// 16 Aug 2000 (AG) corrected include path bug
//
// ****************************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <time.h>

// ONLINE includes
#include "esp.h"

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int acDate;
extern int acTime;

//*****************************************************************
// function
//*****************************************************************

void
acSetDateTime()
{
  ARTE_mark( "acSetDateTime", 0 );

//==================================================================
// no action for MC
//==================================================================

  if (ArteTable<MTRA>::size() > 0 ) return ;

//==================================================================
// 1. set time to acDate, acTime if required by
//    /ALIGNMENT/DATE
//==================================================================

  if (acDate != 0){
   ArtePointer<EVHD>(1)->date = acDate;
   ArtePointer<EVHD>(1)->time = acTime;
  } else {

//==================================================================
// 2. get time from DDAQ bank, fill event header bank
//==================================================================

 if (ArteTable<DDAQ>::size() > 0){ 
  ArtePointer<DDAQ> ddaq( 2 );
  
  int datime = 0;

  EVT_DATA *p = (EVT_DATA *) &ddaq->bits;
  ESP_get_int( &p->event_time, &datime, 1 );

  struct tm *tmTime = localtime( (time_t * ) &datime );

  ArtePointer<EVHD>(1)->date = 
     10000*tmTime->tm_year + 100*(1+tmTime->tm_mon) + tmTime->tm_mday;
  ArtePointer<EVHD>(1)->time = 
     10000*tmTime->tm_hour + 100*tmTime->tm_min + tmTime->tm_sec;

  if (ArtePointer<EVHD>(1)->exp == 1998)  ArtePointer<EVHD>(1)->exp =1;
 };

  };

};


