// ********************************************************************
//
//  Routine:	alca/actaxx2evt.C
//  Author:		Dmitry Golubkov
//
//  Description:	Translates TAHD into EVHD, called from mmrupd_
//
//  Modifications:
//   -- none yet					06/12/00 DG
//   -- ARTE_mark added					14/12/00 DG
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfextse.hh"
#include "rang/zfparext.hh"
#include "rang/Fit.hh"
#include "Otr/OtrI.h"

#include "Otr/OtrEvent.h"

// ONLINE includes
#include "table.h"
#include "esp.h"

#include "farm/fa.hh"
#include "farm/farm.hh"
#include <time.h>





extern "C" void actaxx2evt_()
{
	ARTE_mark( "actaxx2evt_ 0", GRR_OK );
	
	// Also for general mixed tain/ev_in case
	if ( ArteTable<EVHD>::size() )
	{		
		ARTE_mark( "actaxx2evt_ 1", GRR_OK );
		return;
	}

	ArtePointer<TAHD> tahd(1);
	EVHD evhd;

	evhd.evt	= tahd->evt;
	evhd.run	= tahd->run;
	evhd.exp	= tahd->exp;

	time_t unixTime = tahd->time;
	evhd.date	= faDate(&unixTime);
	evhd.time	= faTime(&unixTime);

	evhd.dbmajor	= tahd->dbmajor;
	evhd.dbminor	= tahd->dbminor;

	// One has to compare tahd->vgeo with the one used,
	//	unless we have OTR-only with TACMDOTR::OtrI_gd off
	ArtePointer<GEHD> gehd(1);
	if ( tahd->vgeo != gehd->geom )
	{
		static char *message = 0;
		if( !message ) message = new char[80];
		memset( message, '\0', 80 );
		sprintf( message, "actaxx2evt_: wrong geometry is being used:
				 tahd->vgeo = %f, gehd->geom = %f",
			tahd->vgeo, gehd->geom );

		ARTE_error( GRR_SWARNING, message, GRR_FISHY );

		ARTE_mark( "actaxx2evt_ 1", GRR_FISHY );
		return;
	}

	ArteTable<EVHD>::push_back(evhd);


	ARTE_mark( "actaxx2evt_ 1", GRR_OK );
	return;
}
