// ********************************************************************
//
//  Routine:	alca/actaxxSelectVDS.C
//  Author:		Martin Braeuer
//
//  Description:	VDS-specific TAXX selection function,
//				called from actaxxevnt.C
//
//  Modifications:
//   -- none yet, I do not know what to do here...	05/03/01 DG
//
// ********************************************************************

#include "alca/actaxxComm.hh"
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include <vector.h>
#include "alca/actaxxComm.hh"
#include "alca/actaxxFLG.hh"

int gageTraceTRACK(float , float *, float *);

/* Just an example completely borrowed from actaxxSelectITR() */
void actaxxSelectVDS() {

  int accept;

  vector< ArtePointer<HITB> > hit;
  hit.reserve(32);

  for ( ArteTable<RSEG>::iterator rsegIt = ArteTable<RSEG>::begin();
	rsegIt != ArteTable<RSEG>::end(); ++rsegIt ) {

    ArtePointer<RSEG> rseg(*rsegIt);

    if ( (*rsegIt)->cmp & Rsegc::bitsign
	 || !( (*rsegIt)->cmp & Rsegc::vxd )
	 || (*rsegIt)->fit )	continue;


    hit.clear();

    for( ArteRelationIterator<HITB> hitbit = rseg->hitb.begin();
         hitbit != rseg->hitb.end(); hitbit++ ) {

      ArtePointer<HITB> hitb(*hitbit);
      ArtePointer<GEDE> gede = hitb->gede;
       
      if ( gede->cmp != 1 ) continue;
      accept = 1;

      // clean cut

      for (ArteTableIterator<HITB> hitb1it=gede->hit1; hitb1it != gede->hitl+1; hitb1it.next()) {
        ArtePointer<HITB> hitba(*hitb1it);
        if (hitb==hitba) continue;

        if (fabs(hitb->x - hitba->x) < fabs(taCommVDS.uExc) ) accept=0;
      }

      if (accept) hit.push_back(hitb);
    }

    if ( (int) hit.size() < taCommVDS.nHit ) continue;
  
    // track accepted
    // now fill hits to TAXX

    for ( vector<ArtePointer<HITB> >::iterator hitit=hit.begin(); hitit!=hit.end(); hitit++) {

      ArtePointer<HITB> hitb(*hitit);

      int tmp = actaxxAdd(hitb, rseg, TAFLG::vdssel);

      if ( tmp ==-1	) return;	// Problems with memory allocation to the list
      if ( tmp == 0	) continue;	// Zero HITB pointer

      if ( tmp != (int) hitb.index() ) // Something too strange
      {
          cout << " actaxxSelectVDS : Unbelievable, taAdd( " 
               << hitb.index() << " ) = " << tmp << endl;
	  return;
      }
    }
  }

  return;
}
