// ********************************************************************
//
//  Header:	alca/actaxxCommITR.hh
//  Author:		Torsten Zeuner
//
//  Description:	TAXX command and selection - related stuff
//
//  Modifications:
//   -- creation					08/11/00 DK
//   -- remake						06/12/00 DG
//
// ********************************************************************

// Template of parameters for a detector-specific TAXX selection
extern struct TACommITR
{
	int   nMC, nPC, nTC;	/* min number of hits per MCPCTC */
	float xcut;		/* inclusion region */
	float xexc;		/* exclusion region */

	float zcut;		/* maximum z-extrapolation length */
	float pcut;		/* momentum cut */

	float chi2_neighbour;	/* cut on chi2 with nearest track */

} taCommITR;
