/**********************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/arte/dfrela.c,v $
* $Revision: 1.3 $
* $Author: natasha $
* $Date: 2000/03/31 08:05:51 $
*
* Created: July 7, 1997 by Hartwig Albrecht
*
* Called from: usautt
*
* Arguments:
* *link     Zebra link of the relation
* *name     name of the relation
* div       Zebra division (1: const; 2: event)
* *tab1     Zebra link of one of the related tables
* pos1      position of the pointer within the above table
* *tab2     Zebra link of the other of the related tables
* pos2      position of the pointer within the above table
* flag      1: one-one; 2: one-many; 4: many-many
* *iofiles  input / output files
*
**********************************************************************/

#include <stdio.h>
#include "arte/Arte.h"
#include "auto/MEMO.h"
#include "auto/MEMA.h"

extern void chttoh_ (char *input, char *output, int *nwords);

void dfrela (int *link, char *name, int div, int *tab2,
            int pos2, int *tab1, int pos1, int flag){

  int i, j = 20, l1, l2;

  i = ((unsigned) link - (unsigned) &artelink_.narlnk) / 4;

  /* update ARTELINK */
  { if (i > artelink_.narlnk)
    artelink_.narlnk = i;
    artelink_.larlnl = artelink_.larln1 + 4 * artelink_.narlnk - 4;
  }

  chttoh_ (name, &MEMO(i).name[0], &j);
  MEMO(i).fmt = 2;
  MEMO(i).div = (div == 1) ? gcbank_.ixcons : gcbank_.ixevnt;
  MEMO(i).col = 0;
  MEMO(i).ocol = 0;
  if (flag == 2) MEMO(i).col = 2;
  if (flag == 4) {
    MEMO(i).col = 4;
    MEMO(i).ocol = 2;
  }
  MEMO(i).ext = 2000;
  MEMO(i).flag = flag;
  MEMO(i).pos[0] = pos1;
  MEMO(i).pos[1] = pos2;
  l1 = ((unsigned) tab1 - (unsigned) &artelink_.narlnk) / 4;
  l2 = ((unsigned) tab2 - (unsigned) &artelink_.narlnk) / 4;
  MEMO(i).sup[0] = l1;
  MEMO(i).sup[1] = l2;
  MEMO(i).mema = 1;

  MEMA(MEMO(l2).mema+pos2-1).type = flag;
  MEMA(MEMO(l2).mema+pos2-1).rela = i;
  MEMA(MEMO(l2).mema+pos2-1).relt = l1;
  MEMA(MEMO(l2).mema+pos2-1).relp = pos1;
  if (flag == 2)  flag = 3;
  MEMA(MEMO(l1).mema+pos1-1).type = flag;
  MEMA(MEMO(l1).mema+pos1-1).rela = i;
  MEMA(MEMO(l1).mema+pos1-1).relt = l2;
  MEMA(MEMO(l1).mema+pos1-1).relp = pos2;

}
