//
// This file is part of the C++ interface for Arte
// the HERA-B reconstruction and analysis tool
//
// This is the definition of the ArtePointer class.
//
// ArtePointer allows access to the Arte data tables in
// a pointer-like way.
//
//
// .SS Usage // A Pointer to an GESL is declared as
//
// .ft B
//      ArteRelationPointer<xxx> relPoint;
//
//
// .SS See Also
//
// ArtePointer.hh
//
// Author: Christoph Borgmeier
//

#ifndef _ARTE_RELATION_ITERATOR_HH_
#define _ARTE_RELATION_ITERATOR_HH_

//#ifdef __GNUC__
//#pragma interface
//#endif

#include "arte/RelationPointer.hh"

template <class t>
class ArteRelationIterator: public ArteRelationPointer<t>
{
public:
  inline ArteRelationIterator( const ArteRelationPointer<t>& arg );

  inline int valid() const;
  inline ArtePointer<t> next();

  inline operator ArtePointer<t> () const;
};

#include "arte/RelationIterator.icc"

#endif
