*-- Author :    Hartwig Albrecht   20/09/98

      SUBROUTINE MMWTMM (LUN, IL, IFLAG)

************************************************************************
*
* Description: write one table and the corresponding many-many relations
*
* Called from: MMWRIT
*
* External references: Zebra FZ
*
* Argument in/out description
*   LUN    in     logical unit
*   IL     in     pointer
*   IFLAG  out    0: ok; > 0: error; < 0: file is full
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEMA.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, IL, IN, IFLAG, IR, MMWSTAT
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMA.ff"

C write table

      CALL MMWTAB (LUN, IL, IFLAG)

C look for many-to-many relations

      DO IR = IMEMO_MEMA(IL), IMEMO_MEMA(IL) + IMEMO_OCOL(IL) - 1
        IF (MMWSTAT (LUN, IMEMA_RELT(IR)) .EQ. 0 .AND.
     +    IMEMA_TYPE(IR) .EQ. 4)  THEN
          CALL MMWTAB (LUN, IMEMA_RELA(IR), IN)
          IF (IFLAG .LE. 0)  IFLAG = MIN (IN, IFLAG)
          IF (IN .GT. 0)  IFLAG = IN
        END IF
      END DO

      END

************************************************************************
* End of MMWTMM
************************************************************************
