*CMZ :          17/01/97  17.01.42  by  Unknown
*-- Author :
      SUBROUTINE F0NLXP (FUNC,XFCUM,X2LOW,X2HIGH)
C         F. JAMES,   Sept, 1994
C
C         Prepares the user function FUNC for FUNLUX
C         Inspired by and mostly copied from FUNPRE and FUNRAN
C         except that
C    1. FUNLUX uses RANLUX underneath,
C    2. FUNLXP expands the first and last bins to cater for
C              functions with long tails on left and/or right,
C    3. FUNLXP calls FUNPCT to do the actual finding of percentiles.
C    4. both FUNLXP and FUNPCT use RADAPT for Gaussian integration.
C


      CHARACTER*78 CTEXT 

      REAL     FUNC
      EXTERNAL FUNC
      COMMON/FUNINT/TFTOT
      DIMENSION XFCUM(200)
      PARAMETER (RTEPS=0.0002)
      INTEGER  LENOCC 
      EXTERNAL LENOCC
      SAVE IFUNC
      DATA IFUNC/0/


      IFUNC = IFUNC + 1
C         FIND RANGE WHERE FUNCTION IS NON-ZERO.
      CALL F0NLZ(FUNC,X2LOW,X2HIGH,XLOW,XHIGH)
      XRANGE = XHIGH-XLOW
      IF(XRANGE .LE. 0.)  THEN
       XLOW  = 0 
       XHIGH = 100
      ENDIF
      CALL RADAPT(FUNC,XLOW,XHIGH,1,RTEPS,0.,TFTOT ,UNCERT)

      CALL F0NPCT(FUNC,IFUNC,XLOW,XHIGH,XFCUM,1,99,TFTOT,IERR)
      IF (IERR .GT. 0)  GO TO 900
      X2 = XFCUM(3)
      CALL RADAPT(FUNC,XLOW,X2,1,RTEPS,0.,TFTOT1 ,UNCERT)
      CALL F0NPCT(FUNC,IFUNC,XLOW,X2 ,XFCUM,101,49,TFTOT1,IERR)
      IF (IERR .GT. 0)  GO TO 900
      X3 = XFCUM(98)
      CALL RADAPT(FUNC,X3,XHIGH,1,RTEPS,0.,TFTOT2 ,UNCERT)
      CALL F0NPCT(FUNC,IFUNC,X3,XHIGH,XFCUM,151,49,TFTOT2,IERR)
      IF (IERR .GT. 0)  GO TO 900

      RETURN
  900 CONTINUE
      CTEXT='F0NLXP, fatal error!!'
      CALL MEMESC(1284743,1,ILARGEST,CTEXT(1:LENOCC(CTEXT)))
      END
