//                              -*- Mode: C++ -*-
//: ESCTCValley.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef ESCTCVALLEY_HH_
#define ESCTCVALLEY_HH_

#include "care/ESCTCDisStrat.hh"

/**
class  ESCTCValley.
  Concrete class to evaluate the Cluster-To-Cluster distance 
  with the help of the Valley algorithm
*/

class ESCTCValley : public ESCTCDisStrat {
public:
 
  /// Constructor
  ESCTCValley();
  //-- 
  /// Destructor: currently void but needs to be virtual
  virtual ~ESCTCValley();

  /**@name Beheavioral methods */
  //@{ 
  ///   set the reference cluster to which distances must be evaluated
  virtual void refCluster(EMCluster* clus);
  //--
  ///   evaluate the position for a cluster
  virtual float evaluateDis(EMCluster* clus); 

  //@}
  
  //   Access functions 
  //--
  /// test if the clusters areDifferent
  virtual bool areDifferent() const;

protected:
  // /////////////////// Data Part /////////////////////////////////
  //--
  /// Energy of the main cluster
  Energy_t mainClus;
  //--
  /// Energy of the boundary region cell
  Energy_t boundCell;
 
};

#endif  //   ESCTCVALLEY_HH_
