// *****************************************************************************
//
// source:    get_OTR_hit.C
//
// type:      source code
//
// created:   13 Mar 2001
//
// author:    Lars Soezueer, Ulrich Uwer
//            email: soezueer@mail.desy.de
//
// purpose:   MCGetFedInfo: get fedid, chanid and tdccount of hitb
//            MCGetFedIds: get list of of FEDs for OTR
//            called by daq_otr_if.C
//
// changes:   
//
// *****************************************************************************
#include "Otr/OtrI.h"

int MCGetFedInfo(ArtePointer<HITB> hitb, unsigned short& fedid, 
		 unsigned char& chanid, unsigned char& tdccount)
{
  int rc=0;
  if(hitb->gede->cmp==2) {

    int ci=OtrIFromId(hitb->chid);
    if (!OtrIError()) { 
      fedid  = OtrIFedId(ci);
      chanid = OtrIFedChannel(ci);
      tdccount = OtrITdcValueFromHitb(hitb); 
    } else rc=1 ;

  } 
  else rc=1 ;
  return rc;
}

int MCGetFedIds(unsigned short *buf, unsigned int maxIDs)
{
  unsigned int nfeds = 0; // return variable

  if (buf!=0) {
    unsigned int i;
    nfeds = ((unsigned int) OtrIFedNumberOf()>maxIDs) ? 
      maxIDs:(unsigned int) OtrIFedNumberOf();
    for (i=0; i<nfeds; i++) buf[i]=OtrIFedIdFromIndex(i);
  }

  return (int) nfeds;
}
