#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "arte/Arte.h"
#include "auto/MEMO.h"
#include "auto/MEMA.h"
#include "auto/MEMS.h"
#include "auto/MEIO.h"
#include "dbarte/DbArteBridge.h"
#include "arte/ArteFlag.h"
#include "arte/mecCount.h"


extern DbFileDesc *DbFileDescList;


void chhtot_(char *, char *, int *);
void iounit_(char *, int *, int);
void DbToUpper( char *Csym, int len );


void DbListFile(char *CsymIn) 
{

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   *
   * Description: List the content of a MIZZI file.
   *
   * Called from: anywhere.
   *
   * External references: MIZZI functions.
   *
   * Argument in/out description
   *  Csym    in     symbolic name (GEOMIN, GEOMOUT, ...)
   *
   *
   ************************************************************************/

  char *tbname, mess[80]="DBLFIL: ";
  char Csym[DB_MAX_NAME_SIZE+1],Csymt[DB_MAX_NAME_SIZE+1];
  int xe, major, minor, len;
  int flag = 1;
  Tables x;
  DbFileDesc *FD;
  int var;
  
  len=strlen(CsymIn);

  strcpy(Csym,CsymIn);
  DbToUpper( Csym, len );

  var = len/4 + (len%4?1:0);
  chhtot_( Csym, Csymt, &var );
  
  for(FD=DbFileDescList;FD;FD=FD->next)
	  if(strcmp(FD->Csym,Csymt)==0)
		  break;

  if( FD == NULL ) {
    static int errPtr;
    sprintf(mess+strlen(mess),
       "symbolic name %s is not connected to a file/server", Csymt );
    mecErrorCount( &errPtr, mess );
    return;
  }

  x = FD->Id;

  printf( "\nListTables: Listing tables for file/server %s\n", FD->Name );
  SearchTable(x,0,"","");
  while( (tbname = SearchTable(x,1,0,0)) ) {
    flag = 0;
    xe = BookTable( x, tbname, 0, 0 );

    printf( "\n===>Name    '%s'\n", tbname );
    printf(   "--->Title   '%s'\n", TableTitle(x,xe) );
    printf(   "--->Format  '%s'\n", TableDescription(x,xe) );

    TableStamp( x, 0, 0 );

    printf( "--->Entries\n" );

    for( TableStamp( x, 0, 0 ) ; MatchTable( x, xe, 1 ) ; 
	 TableStamp( x, major, minor ) ) {

      major = TableMajor(x);
      minor = TableMinor(x);

      printf( "    Major = %d          Minor = %d\n", major, minor );

    }
    UnbookTable( x, xe );
  }

  if( flag ) {
    strcat( mess, "file empty\n");
    mecAllPrint( mess );
  }
  return;
}

