
// ******************************************************************
//
// A. Gorisek 18/07/2001
//
// Filling of histograms
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"
#include "grr.h"

// ARTE includes
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "dq/DQ.h"
#include "farm/farm.hh"

// externals
extern int FAGRR;


//////////////// Fill GLAL histograms /////////////////////////////
int DQ_CORR_rec_evnt() {
  // show up
  ARTE_mark( "DQ_CORR_rec_evnt 0", 0 );

  for( ArteTable<RTRA>::iterator rtrait=ArteTable<RTRA>::begin();
       rtrait!=ArteTable<RTRA>::end(); ++rtrait ) {
    ArtePointer<RTRA> rtra(rtrait) ;      

    float PCseg[6], VDSseg[6] ;
    int isvxdseg=0, ispattseg=0 ;
    for ( ArteRelationIterator<RSEG> rsegit = rtra->rseg.begin() ;
	  rsegit != rtra->rseg.end(); rsegit++ ) {
      ArtePointer<RSEG> rseg(rsegit) ;      

      if ( rseg->cmp & Rsegc::vxd ) { //VDS segment
	VDSseg[0]=rseg->ze ;
	VDSseg[1]=rseg->xe ;
	VDSseg[2]=rseg->ye ;
	VDSseg[3]=rseg->txe ;
	VDSseg[4]=rseg->tye ;
	VDSseg[5]=rseg->pe ;
	isvxdseg++ ;
      } else if ( (rseg->cmp & Rsegc::patt) &&
		  (rseg->zf>680.) &&
		  (rseg->ze<860.) ) { //PC segment
	PCseg[0]=rseg->zf ;
	PCseg[1]=rseg->xf ;
	PCseg[2]=rseg->yf ;
	PCseg[3]=rseg->txf ;
	PCseg[4]=rseg->tyf ;
	PCseg[5]=rseg->pf ;
	ispattseg++ ;
      }

    }

    if ( isvxdseg>1 ) cerr <<  "############# more than 1 VDS seg!!!\n" ;
    if ( ispattseg>1 ) cerr << "############# more than 1 PC seg!!!\n" ;

    if ( ispattseg==1 && isvxdseg==1 ) {
      float zX ;
      zX = ((PCseg[1]-PCseg[3]*PCseg[0])-(VDSseg[1]-VDSseg[3]*VDSseg[0]))/
	(VDSseg[3]-PCseg[3]) ;
      rhp_hf1(DQ_ID(COMP_CORR,LVL_REC,1001),zX,1.);
      rhp_hfill(DQ_ID(COMP_CORR,LVL_REC,2001),VDSseg[3]-PCseg[3],zX,1);
    } 
  }

  ARTE_mark( "DQ_CORR_rec_evnt 1", 0 );

  return 0; // return error code (0 = okay)
}

