
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// Filling of histograms
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
//         histogram id: 1 - 65535
//
// changes:
// 22 Oct 1999 (AG) code polishing
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 12 Dec 2000 (MB) changed something
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int
DQ_MUON_rec_evnt()
{
  // show up
  ARTE_mark( "DQ_MUON_rec_evnt 1", 0 );

  // filling
  int nrMUONtracks=0;
  for(ArteTableIterator<RTRA> track;track.valid();track.next())
    {
      //      float hmu=track->hmu;
      //      float lmmu=track->lmmu;
      //      float lmh=track->lmh;
      //      float flm=track->flm;
      //      float lmu=track->lmu;

      /* MUON track */
      if(track->lmmu > 0.0001)
        {
          rhp_hf1(DQ_ID(COMP_MUON,LVL_REC,0x100),track->hmu,1);
          nrMUONtracks++;
        }
    }
 
  rhp_hf1(DQ_ID(COMP_MUON,LVL_REC,0x1),nrMUONtracks,1);

  ARTE_mark( "DQ_MUON_rec_evnt 1", 0 );
  return 0; // return error code (0 = okay)
}
