//                              -*- Mode: C++ -*-
//
// Particle.cc - base class particle
//
// Copyright (C)  1993  The Board of Trustees of The Leland Stanford
//                      Junior University.  All Rights Reserved.
//
// $Id: DQ_Particle.C,v 1.1 2000/04/19 20:42:14 natasha Exp $

#ifdef __GNUC__
#pragma implementation
#endif

#include "dq/DQ_Particle.hh"

void Particle::printAncestry(ostream &str, int level)
{
     str << this;
     int n = nChildren();
     if (n > 0)
     {
          str << " (" << n << " children) -> ";
          for (int i=0; i < n; i++)
               str << child(i) << ' ';
          str << '\n';
          for (int i=0; i < n; i++)
          {
               for (int j=0; j<=level; j++) str << "  ";
               child(i)->printAncestry(str, level+1);
          }
     }
     else
          str << " (no children)\n";
}

Particle::Particle(const HepLorentzVector &v)
: HepLorentzVector(v)
{
     _pdtEntry = 0;
}

/*
Particle::Particle(HepLorentzVector &v, PDTEntry *pd)
: HepLorentzVector(v)
{
     _pdtEntry = pd;
     if (_pdtEntry != NULL) _charge = _pdtEntry->charge();
     else _charge = 0;
     _parent = NULL;
}
*/
/*
void Particle::setIDAdjustE(PDTEntry *ent)
{
     _pdtEntry = ent;
     setMass(_pdtEntry->mass());
     _charge = _pdtEntry->charge();
}

void Particle::setIDAdjustP(PDTEntry *ent)
{
     _pdtEntry = ent;
     float m = _pdtEntry->mass();

     float pscale =  sqrt( (ee()*ee() - m*m) / pTot2() );
     *(Hep3Vector *)this *= pscale;
     _charge = _pdtEntry->charge();
}

ostream & operator<<(ostream &os, HepLorentzVectorD const &p){
  os<<"P:("<<p.t()<<"; "<<p.x()<<", "<<p.y()<<", "<<p.z()<<") ";
  return os;
}
*/










