
// ******************************************************************
//
// M. Braeuer / D. Samtleben
//
// changes:
// 20 Oct 1999 (AG) code polishing
// 22 Oct 1999 (AG) polish SVD stuff
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
// 30 May 2000 (GS) hits/event histo booking range extended
// 26 Sep 2000 (GS) unused hits/event histo booking range extended
// 28 Nov 2000 (GS) Arte_mark included
//  8 Dec 2000 (GS) Hits/evnt histo duplicated for mb and slt events
// 14 Dec 2000 (GS) some histogram titles and ranges modified
// 19 Dec 2000 (AG) polished printout
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

//
// function code
//
int
DQ_SVD_hit_init()
{

  // definitions and Vars for the VDS

#define VDS_MAXPLANES  128
 
#define VDS_plane_l  -0.5  // lower bound for plane
#define VDS_plane_h 127.5  // upper bound for plane
 
  // show up
  ARTE_mark( "DQ_SVD_hit_init", 0 );
  cout << "DQ_SVD_hit_init" << endl;

//======================================================================
//      now GEDE-independent booking
//======================================================================
  
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,99),"VDS hits/event*rate raw mb", 
	     1000,-0.5,999.5);
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,100),"VDS hits/event*rate raw slt", 
	     1000,-0.5,999.5);
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,101),"VDS hits/rate vs plane raw",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h);
  rhp_hbook2(DQ_ID(COMP_SVD,LVL_HIT,102),"VDS occupancy/rate raw",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h, 128,0.,1280.);
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,301),"VDS no of unused hits/event*rate",
	     1000,-0.5,999.5);

  ARTE_mark( "DQ_SVD_hit_init 1", 0 );
  return 0; // return error code (0 = okay)
}
