#include <stdio.h>
#include <string.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteIOlun.h"
#include "arte/ZQUEST.h"
#include "arte/ArteMessage.hh"
#include "gean/zgmed.hh"

extern "C" {
   void crgean_();
   void ioconc_(int *, char *, char *, int *, int, int);
   void iofind_(char *,int *,int);
   void ioopen_(int *,char *,int *,int *,int);  
   void iounit_(char *, int &, int);
   void ioclos_(int *);
   void cfopen_(int*, int *,int *,char *,int *,char *,int *);
   void gopen_(int *,char *,int *, int *,int);
   void gfout_(int *, char *,int *,int *,char *,int *,int , int);
   void gfin_( int *, char *,int *,int *,char *,int *,int , int);
   void ggclos_();
   void crzgmoth_();
   void gclose_(int*, int*); 
   void rgnini_();
   void dggehd_();
   void dggept_();
   void mmread_(int &, char *, const int);
   void DbOpen(int,char*,int,int*);
   void DbClose(int,int*);
   void DbReadHeader(int, int *, int, int, char *,int *);
}
   void gvers();
   void medmain();
   void fldgeo();
  
void crgean_() {
  extern int Gean_Status;
   int ier=0,  lun=18,  i0=0,  i1=1,  i1024=1024;    
   int igeom = int(10000.*arteflag_.geomvers+.1);   
   iofind_("GEANBK",&lun,6);
   ArtePointer<MEIO> mio(lun);

   if(Gean_Status == 1) {
      ioopen_(&lun,"LO",&i0,&ier,2);
      if(ier) {
         arteMsg << "ioopen fails" ; arteMsg.error(); 
      }
      quest_.iquest[0] = mio->cfopen;
      gopen_(&lun,"LO",&i1024,&ier,2);       
      if(ier) {
         arteMsg << "gopen fails " ; arteMsg.error(); 
      }
      gfout_(&lun,"INIT",&i1,&igeom," ",&ier,4,1);
      if(ier == 0 || ier >= 7) {}
      else if(ier < 0) {
        arteMsg << "gfout fails " << ier; arteMsg.warn();
      }
      else { 
	arteMsg << "gfout not completely written out " << ier;
	arteMsg.warn();
      }
      ioclos_(&lun);
   }

   else if(Gean_Status == 3) {
      gvers();  
      char fname[128];
//    get input file GEANBK
      if(mio->flag < 1 ) {
       strcpy(fname,getenv("HBROOT"));
       strcat(fname,"/GEO/GEAN/gean");
       char txt[7];  sprintf(txt,"%06d",igeom);
       strcat(fname,txt); 
       strcat(fname,".out");
       ioconc_(&lun,fname,"LI",&i0,strlen(fname),2);
     } 

      ioopen_(&lun,"LI",&i0,&ier,2);
      if(ier) {
	arteMsg << "ioopen fails " << ier;  arteMsg.error(); 
      }
      quest_.iquest[0] = mio->cfopen;
      gopen_(&lun,"LI",&i1024,&ier,2);      
      if(ier) {
	arteMsg << "gopen fails " << ier;  arteMsg.error(); 
      }
      gfin_(&lun,"INIT",&i1,&igeom," ",&ier,4,1);
      if(ier == 0 || ier >= 7) {}
      else if(ier < 0) {
	arteMsg << "gfin fails" << ier; arteMsg.error();
      }
      else { 
	arteMsg << "gfin not completely read in " << ier;
	arteMsg.warn();
      }
      ioclos_(&lun); 

      ier=0; 
      iounit_( "GEOMIN", lun, 6 );    //  check whether GEOMIN exit before 
      ArtePointer<MEIO> mg(lun);
      mg =ArtePointer<MEIO>(lun);
      if(mg->flag < 2 ) {
//       take from DB    
         iounit_( "GEODB", lun, 5 );
         ArtePointer<MEIO> me(lun);
         if(me->flag < 1) {
            arteMsg << "dggeomread: IOFILE GEODB not declared";
            static int Warn = 0x00c0ead2;      
            arteMsg.warn(Warn);
         }

         int var; char Name[128];
         strncpy(Name,me->name,120);  
         for(var=0;var<120 && Name[var] && Name[var]!=' ';var++);
         Name[var]=0;
         DbOpen( lun, Name, 0, &ier );

         int nlink=0;
         for( ArteTableIterator<MEMO>mo; mo.valid(); mo.next()) {
            if(!strncmp("NGHD", mo->name,4 ) ) {
               nlink = mo.index(); 
               break; 
            } 
         }
         if( nlink == 0 ) {
            arteMsg <<  "bank " << Name << " is not booked in MEMO bank";
            arteMsg.error();
         }

         int Major = int(arteflag_.geomvers + .1);  
         int Minor = int(10000.*arteflag_.geomvers + .1) - 10000*Major;    
         DbReadHeader( lun, (int *)((artelink_.larln1.getRef() + nlink)*4), 
                                           Major, Minor, "EQ", &ier );
         if(ier) {
            arteMsg << "GeomReadFarm: detector geometry not found";
            static int Warn = 0x00c0ead2;      
            arteMsg.warn(Warn);
         }
         else {
           arteMsg << "geometry version" << Major<<" "<< Minor << " is taken";
           arteMsg.warn();
         }
         DbClose( lun, &ier);      
      }         
      if(!ArteTable<GEHD>::booked() || !ArteTable<GEHD>::size()) dggehd_();
      dggept_();

      crzgmoth_();
      medmain();
      zgmed ZGMED;
      ZGMED.Fill_hg_tmed();  
      fldgeo();
      rgnini_();
      ggclos_();
   }
}
