
/***********************************************************************
* Author :    Siegmund Nowak   22/01/96
*
* gtest_fill
* written by Siegmund Nowak, 22/01/96 15.04.32
*
* This routine is for filling of gean test histograms
*
* The call must be inserted
* called from usevnt for geant-switch 1  (siout1)
*        from usstep for geant-switch 3  (siout3)
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "arte/arte.hh"
#include "arte/ArteUtil.h"
#include "gean/gcflag.h"
#include "gean/gcnum.h"
#include "gean/gclink.h"
#include "gean/gctrak.h"
#include "gean/gcvolu.h"
#include "gean/ZGMOTH.h"

extern "C" {
  void hf1_(int*,float*,float*);
  void hf2_(int*,float*,float*,float*);
}   

void siout1();
void siout3();
long gtf_timold=0; 

void gtest_fill() { 

  if     (gcflag_.iswit[5] == 1) siout1();
  else if(gcflag_.iswit[5] == 3) siout3();
}

void hf1( int id, float xl, float xw ){
  hf1_(&id, &xl, &xw);
}

void hf2( int id, float xl, float x2, float xw ){
  hf2_(&id, &xl, &x2, &xw);
}


void siout1() {
  long t = time(NULL); 
  if(gtf_timold > 0.) {
     long dt = t-gtf_timold;   hf1(1,float(dt),1.);
  }
  gtf_timold = t;

      
  hf1(2,float(gcnum_.nvertx),1.);
  hf1(3,float(ArteTable<MVER>::size()),1.);
  hf1(4,float(gcnum_.ntrack),1.);
  hf1(5,float(ArteTable<MTRA>::size()),1.);
  hf1(6,float(ArteTable<MIMP>::size()),1.);
  hf1(7,float(ArteTable<MCAL>::size()),1.);
  hf1(8,float(ArteTable<MTCP>::size()),1.);      

  int mt_origin = 0; 
  for(ArteTableIterator<MTRA> mt; mt.valid(); mt.next()) { 
     ArtePointer <TOPP> icod = mt->topp;
     div_t j = div(icod.index()-1,100);
     hf1(30+j.quot,float(icod.index()),1.);
     float pt = sqrt(mt->px*mt->px + mt->py*mt->py);
     float p = sqrt(pt*pt + mt->pz*mt->pz);
     if(p < 1.) hf1(36,p,1.);
     else      hf1(37,p,1.);
     hf1(38,float(mt->flag),1.);
     hf1(39,mt->ml,1.);
     hf1(40,pt,1.);
     if(mt->bver == 1) { 
        if(mt->flag == 2 && icod.index() != 100) continue;
        mt_origin++;
        hf1(41+j.quot,float(icod.index()),1.);
        hf1(47,p,1.);
        hf1(48,pt,1.);
     }
  }
  hf1(49,float(mt_origin),1.);

  int nsubdet_mimp[10]={0,0,0,0,0,0,0,0,0,0};
  for (ArteTableIterator<GESL> sl;sl.valid();sl.next()) {
     for (int ipl = sl->fpl;ipl < sl->fpl+sl->npl;ipl++) {
	if(sl->cmp != 7) {  
          ArtePointer<GEDE> gd(ipl);
          int nmim = 0;
          int ifmimp  = gd->mim1.index();
          if(ifmimp) nmim  = gd->miml.index() - ifmimp + 1;
          if(nmim > 0) {
            hf1(100,float(sl.index()),float(nmim)); 
            if(sl->cmp != 5) {
               nsubdet_mimp[sl->cmp-1] = nsubdet_mimp[sl->cmp-1] + nmim;
	       hf1(sl->cmp*100+sl->nsl,float(ipl),float(nmim)); 
	    }
            else {
	      hf1(sl->cmp*100+sl->nsl,float(ipl),float(nmim)); 
	      if (ipl == sl->fpl) 
               nsubdet_mimp[sl->cmp-1] = nsubdet_mimp[sl->cmp-1] + nmim;
              else 
               nsubdet_mimp[9] = nsubdet_mimp[9] + nmim;
            }
          }
          int nhit = 0,  ifhit  = gd->hit1.index();
          if(ifhit) nhit  = gd->hitl.index() - ifhit + 1;
          if(nhit > 0) {
            hf1(sl->cmp*100+20+sl->nsl,float(ipl),float(nhit));
            hf1(200,float(sl.index()),float(nhit));
          }
        }
        else {
          ArtePointer<GCAL> gd(ipl);
          int nmim = 0;
          int ifmimp  = gd->mim1.index();
          if(ifmimp) nmim  = gd->miml.index() - ifmimp + 1;
          if(nmim > 0) {
            nsubdet_mimp[sl->cmp-1] = nsubdet_mimp[sl->cmp-1] + nmim; 
            hf1(100,float(sl.index()),float(nmim));
          } 
        }
     }
  }
  hf1(10,float(nsubdet_mimp[0]),1.);
  hf1(11,float(nsubdet_mimp[1]),1.);
  hf1(12,float(nsubdet_mimp[2]),1.);
  hf1(13,float(nsubdet_mimp[3]),1.);
  hf1(14,float(nsubdet_mimp[4]),1.);
  hf1(15,float(nsubdet_mimp[5]),1.);
  hf1(16,float(nsubdet_mimp[7]),1.);
  hf1(17,float(nsubdet_mimp[8]),1.);
  hf1(18,float(nsubdet_mimp[9]),1.);
  
    
  for (ArteTableIterator<MCAL> mcal;mcal.valid();mcal.next()) {
     ArtePointer<GCAL> gc((mcal->gcal & 0x00FFFFFF)/100);
     float ncol = .5 * (gc->xmin + gc->xmax)/(gc->xmin - gc->xmax) +28.;
     float nrow = .5 * (gc->ymin + gc->ymax)/(gc->ymin - gc->ymax) +21.; 
     hf2(700,ncol,nrow,mcal->de);
  }
}






void siout3() {
  float zvect = gctrak_.vect[2]-zgmoth_.ZZERO;
  if(zvect > 1330.) {
     gctrak_.istop =1;
     return;
  }
  int jvos = 
      *(gcbank_.lq + gclink_.jvolum -1 - gcvolu_.lvolum[gcvolu_.nlevel-1]);
  int *pji = gcbank_.iq + jvos +1;
  float *pjx = (float*)pji;
  int shape = int(*pjx);
  int shapflag=0;
  if(shape > 4 && shape < 10) {
    if(gcvolu_.grmat[(gcvolu_.nlevel-1)*10 +9] == 0.){ shapflag =1;
    }
      
  }
  float radius = sqrt
        (gctrak_.vect[0]*gctrak_.vect[0] + gctrak_.vect[1]*gctrak_.vect[1]);
  hf1(101,float(gcvolu_.lvolum[gcvolu_.nlevel-1]),1.);
  hf1(102,float(gcvolu_.lvolum[gcvolu_.nlevel-1]),1.);
  hf1(103,float(gcvolu_.lvolum[gcvolu_.nlevel-1]),1.);
  hf1(104,float(gcvolu_.lvolum[gcvolu_.nlevel-1]),1.);
  hf2(105,zvect,gctrak_.vect[0],1.);
  hf2(106,zvect,gctrak_.vect[1],1.);
  if(shapflag) {
     hf2(107,zvect,radius,1.); 
     hf2(108,zvect,radius,1.);
  }
  if(zvect <=  200.) { 
     hf2(110,zvect,gctrak_.vect[0],1.);
     hf2(111,zvect,gctrak_.vect[1],1.);
     if(shapflag) hf2(112,zvect,radius,1.);
  }
  else if(zvect >  180.  &&  zvect <=  700.) {     
     hf2(120,zvect,gctrak_.vect[0],1.);
     hf2(121,zvect,gctrak_.vect[1],1.);
     if(shapflag) hf2(122,zvect,radius,1.);
  }
  else if(zvect >  680.  &&  zvect <=  1180.) {     
     hf2(130,zvect,gctrak_.vect[0],1.);
     hf2(131,zvect,gctrak_.vect[1],1.);
     if(shapflag) hf2(132,zvect,radius,1.);
  } 
  else if(zvect >  1180.  &&  zvect <=  1330.) {     
     hf2(140,zvect,gctrak_.vect[0],1.);
     hf2(141,zvect,gctrak_.vect[1],1.);
     if(shapflag) hf2(142,zvect,radius,1.);
  }

}


    






