/***********************************************************************
*
* GVERS
* written by Siegmund Nowak
*
* This routine stores the subdet version numbers and datefiles during
* geometry installation
*
* called from geomain
*
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteFlag.h"
#include "gean/hgdat.h"
#include "gean/zgvers.hh"

FILE *utfilp(const char*,const char*);

void gvers()  {
     int nitem;
     char  buffer[256], tag[80], taga[16], filnam[80]; 
     char *card;
     zgvers::ini(32);
     zgvers ZGVERS;
     ZGVERS.Set_default();     

//  select file name and  open the file    
     int geovers = int(10000.*arteflag_.geomvers + .1);
     sprintf(taga, "%6d", geovers);
     for(int m=0;m<6;m++) {if(taga[m] == ' ') taga[m] = '0'; else break; }    
     strcpy(filnam,"GVERS/gvers\0"); 
     strncat(filnam,taga,6); strcat(filnam,".dat\0");
     FILE *vers_inp = utfilp(filnam,"");

     for(;;) {
        memset(buffer,' ',255);
        buffer[255] = '\0'; 
        if(fgets(buffer,256,vers_inp) == NULL) {
           if(feof(vers_inp)) { fclose(vers_inp);     break;  }
           else continue; }
        card=&buffer[0];
        nitem=sscanf(card,"%s",tag);
        if (nitem==-1) continue;   
        card+=itemlength(card,nitem);
        ToLower(tag);
        if (!strncmp(tag,"geovers",7)) {
           float nr;
           nitem=sscanf(card,"%f",&nr);
           if(nr == arteflag_.geomvers) {  
              ArtePointer<NGHD> ghd(1);
              ghd->geom = arteflag_.geomvers;
              ghd->gean = arteflag_.geanvers; 
           }
           else { arteMsg << "geomvers " << arteflag_.geomvers << 
                 " and geomvers in file " << nr << " differ" ; 
                 arteMsg.error();
           }
        }
         
       	else if(!strncmp(tag,"vers",4)) ZGVERS.Read_geovers(card); 
     }

}


        









