
*-- Author :    B.Fominykh 06/02/96
*
      SUBROUTINE  MUOMED
C     =================
*
* defines materials and media for 3 types of muon chambers
* all materials are implemented as mixture of chamber material with gas
*
      IMPLICIT NONE
      CHARACTER*12 NAM_MIX(2)
      INTEGER IMED,MEDNUM
      REAL CCDR1(2),CCDR2(2),CCDCC(2),EMUCUT
      DATA CCDR1/0.653 , 0.347/
      DATA CCDR2/0.781 , 0.219/
      DATA CCDCC/0.93  , 0.07 /
      DATA EMUCUT /.001/
* -----------------------------------
* 
* material for tube chambers  MAT_MD1
      NAM_MIX(1) = 'MUON_GAS'
      NAM_MIX(2) = 'ALUMIN_MU'
      CALL CRMIXT('MU_WIRE_CHAM',4,2,NAM_MIX,CCDR1)
*
* material for pad chambers
      CALL CRMIXT('MU_PAD_CHAM',4,2,NAM_MIX,CCDR2)

      NAM_MIX(2) = 'CAPTON'
      CALL CRMIXT('MU_PIX_CHAM',4,2,NAM_MIX,CCDCC)
*
* special cuts

      IMED = MEDNUM(1,'IRON_MU')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(1,'ALUMIN_MU')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(1,'AIR_MU')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(1,'VACUUM_MU')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(1,'MUON_CONCRET')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(1,'FERRITE')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(3,'MU_WIRE_CHAM')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(3,'MU_PAD_CHAM')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      IMED = MEDNUM(3,'MU_PIX_CHAM')
      CALL GSTPAR(IMED,'CUTGAM',EMUCUT)
      CALL GSTPAR(IMED,'CUTELE',EMUCUT)

      RETURN
      END





