*-- Author :    Hartwig Albrecht   04/10/95

      SUBROUTINE KADECA

************************************************************************
*
* Description: DECAY command
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/TDEC.fi"
#include "auto/TOPP.fi"

      INTEGER TPNAM1, LPOS, I, L
      CHARACTER CN*12

#include "arte/Arte.ff"
#include "auto/TDEC.ff"
#include "auto/TOPP.ff"

      IF (DECAINIT .EQ. 0)  THEN
        CALL MEERRC (6123496,
     +    'DECAY command must be preceded by a BEGDECAY command')
        GO TO 90
      END IF

C try to find an unused position in TDEC:

      IF (JTDEC .EQ. 0)  GO TO 20
      DO 10 LPOS = 1, NTDEC()
        IF (ITDEC_MOTH(LPOS) .EQ. 0)  GO TO 30
 10   CONTINUE

 20   CALL MMBOOK (JTDEC, 1)
      LPOS = NTDEC()

 30   CALL KUGETI (IQ(IQTDEC_MDME(1,LPOS)))
      CALL KUGETI (IQ(IQTDEC_MDME(2,LPOS)))
      CALL KUGETR ( Q( QTDEC_BRAT(LPOS)))

      DO 40 I = 1, 5
        IQ(IQTDEC_DAUG(I,LPOS)) = 0
        CN = ' '
        CALL KUGETS (CN, L)
        IF (L .EQ. 0)  GO TO 40
        IQ(IQTDEC_DAUG(I,LPOS)) = TPNAM1 (CN)
        IF (ITDEC_DAUG(I,LPOS) .EQ. 0)  THEN
          C78 = 'DECAY: unknown decay particle'
          CALL CH78BC (CN)
          CALL CH78BC ('for decay of')
          CALL CHHTOC (IQ(HQTOPP_NAME(1,DECAINIT)), CN)
          CALL CH78BC (CN)
          CALL ME78EC (63475134)
        END IF
 40   CONTINUE

C keep the original order of DECAY statements

      IQ(IQTDEC_MOTH(LPOS)) = DECAINIT
      IQ(IQTDEC_NEXT(LPOS)) = 0
      L = ITOPP_TDEC(DECAINIT)
      IF (L .EQ. 0)  THEN
        IQ(IQTOPP_TDEC(DECAINIT)) = LPOS
        GO TO 90
      END IF

 50   IF (ITDEC_NEXT(L) .EQ. 0)  GO TO 60
      L = ITDEC_NEXT(L)
      GO TO 50

 60   IQ(IQTDEC_NEXT(L)) = LPOS

 90   END

************************************************************************
* End of KADECA
************************************************************************
