*-- Author :    Hartwig Albrecht   05/03/95

      SUBROUTINE KAFLUN (LUN, INFILE)

************************************************************************
*
* Description: Get unit number from KUIP. Find an unused unit number
*              if the symbolic name not yet declared.
*
* Called from: anywhere
*
* External references: UTKUGC, IOUNIT
*
* Argument in/out description
*   LUN    out    output unit
* INFILE   out    = 1 if input file
*
* check for input file added T.Oest        15.2.99
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      INTEGER L, LUN, INFILE
      CHARACTER*(80) CSYM

#include "arte/Arte.ff"

      CALL UTKUGC (0, LUN, CSYM, L)
      IF (L .NE. 0)  THEN
        CALL IOFIND (CSYM, LUN)
      ELSE
        IF (LUN .LE. 0 .OR. LUN .GE. 100)  THEN
          CALL MEERRC (28,
     +     'IO: logical unit number is not in the range 1 ... 99')
          LUN = 0
        END IF
      END IF

* new: check for input file
      IF ((CSYM(1:5) .EQ. 'EV_IN')   .OR. (CSYM(1:4).EQ. 'EVIN' ) .OR.
     +    (CSYM(1:7) .EQ. 'MINI_IN') .OR. (CSYM(1:7).EQ. 'EDIR_IN') .OR.
     +    (CSYM(1:11).EQ. 'DST_IN_EDIR') .OR.
     +    (CSYM(1:12).EQ. 'MINI_IN_EDIR') .OR.
     +    (CSYM(1:6) .EQ. 'GEOMIN')                            ) THEN
       INFILE = 1
      ELSE
       INFILE = 0
      ENDIF


      END

************************************************************************
* End of KAFLUN
************************************************************************
