*CMZ :  1.00/01 25/03/95  17.32.45  by  Fedor Ratnikov
*CMZ :  1.00/00 14/12/94  21.47.46  by  Dominik Ressing
*-- Author :    Dominik Ressing   27/07/94
************************************************************************
*
* L1HITIF
* written by Dominik Ressing, 27/07/94 17.18.03
*
* This routines action:
* returns outline of full cell in specified detector
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iDetSpe     in          detector specifier as defined in $l1detdf
* iHit        in          cell number
* rGeoInf     out         Geometry description as defined in $l1detdf
*
************************************************************************
c
      SUBROUTINE L1HITIF(iDetSpe,iHit,rGeoInf)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
c
      INTEGER iDetSpe(L1DETSPElen),iHit,iDetInfo(L1DETINFlen)
      REAL    rGeoInf(L1GEOINFlen),dy
c
      INTEGER nHit,             ! number of hits in a row (y=const)
     &        jCellGeo,         ! geometry of a detector cell
     &        jDetInfo,         ! information about detector cells
     &        jDetGeo           ! geometry of detector
c
c
      CALL l1detif(iDetSpe,jDetGeo,jDetInfo,jCellGeo) ! get detector geometry
      if ( jDetGeo.le.0 ) GO To 777                   ! no success
c
      rGeoInf(L1GEOINFz      ) = Q(jDetGeo+L1GEOINFz      ) ! z of detector plane
      rGeoInf(L1GEOINFsin_al ) = Q(jDetGeo+L1GEOINFsin_al ) ! alpha of detector layer
      rGeoInf(L1GEOINFcos_al ) = Q(jDetGeo+L1GEOINFcos_al ) ! alpha of detector layer
c
      IF ( IQ(jDetInfo+L1DETINFwirepad).eq.1 ) THEN    ! wire-like detector
c
         rGeoInf(L1GEOINFx0) =
     &      float(iHit-1)*Q(jDetInfo+L1DETINFxspace) +
     &      Q(jDetGeo+L1GEOINFx0)
         rGeoInf(L1GEOINFy0) = Q(jDetGeo+L1GEOINFy0)
         rGeoInf(L1GEOINFsy) = Q(jDetGeo+L1GEOINFsy)
         rGeoInf(L1GEOINFsx) = Q(jCellGeo+L1GEOINFsx)
c
      ELSE  ! pad -like detector
c
         nHit = IQ(jDetInfo+L1DETINFnRow)
         dy = Float(INT((iHit-1)/nHit))*Q(jDetInfo+L1DETINFyspace)
         rGeoInf(L1GEOINFy0) = dy + Q(jDetGeo+L1GEOINFy0)
         rGeoInf(L1GEOINFx0) =
     &      FLOAT(MOD(iHit-1,nHit))*Q(jDetInfo+L1DETINFxspace) +
     &        Q(jDetGeo+L1GEOINFx0) +
     &        dy*Q(jDetGeo+L1GEOINFsin_al)/Q(jDetGeo+L1GEOINFcos_al)
         rGeoInf(L1GEOINFsy) = Q(jCellGeo+L1GEOINFsy)
         rGeoInf(L1GEOINFsx) = Q(jCellGeo+L1GEOINFsx)
c
      END IF
c
      RETURN
c
 777  CONTINUE
c     --- error exit
      CALL VZERO(rGeoInf,L1GEOINFlen)
      WRITE(L1LUNprn,900) iDetSpe(L1DETSPEdet),
     &                    iDetSpe(L1DETSPElayer),
     &                    iDetSpe(L1DETSPEsection),
     &                    iHit
 900  FORMAT(1x,
     & 'L1HITIF ==> invalid detector iseq-det,layer/section/iHit:'
     & /10x,4i8)
c
      RETURN
c
      END
