*CMZ :  1.00/01 11/12/94  10.24.15  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   20/11/94
************************************************************************
*
* L1KINE1
* written by  Ivan Belyaev, 20/11/94 13.03.05
*
* This routines action:
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* var1        in           this variable will only be read
*
*
************************************************************************
c
      SUBROUTINE L1KINE1(Point1,Point2,Pmin,Pmax,z,
     &                   nROI,ROI1,ROI2)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mesdf.fi"
c
      REAL Point1(L1GEOINFlen),Point2(L1GEOINFlen),Pmin,Pmax,z,
     &     ROI1(0:L1ROIlen),ROI2(0:L1ROIlen)
      INTEGER nROI
c
      REAL x1( 4 ) , y1( 4 ) , z1 , zE
      REAL x2( 4 ) , y2( 4 ) , z2 , dZ
      REAL xMin , yMin ,xMax , yMax
      REAL xPo( 16 ) , yPo( 16 ) ,dXdZ , dYdZ , zFactor
      INTEGER iPo1 , iPo2 , iPo , nPo
c
      IF ( Point2(L1GEOINFz).lt.0. ) THEN
         WRITE (L1LUNprn,*) 'L1KINE1==> invalid point 2'
         nROI = 0
         RETURN
      END IF
      IF ( Point1(L1GEOINFz).lt.0. ) THEN
         WRITE (L1LUNprn,*) 'L1KINE1==> invalid point 1'
         nROI = 0
         RETURN
      END IF
c
      x1( 1 ) = Point1( L1GEOINFx0 )
      y1( 1 ) = Point1( L1GEOINFy0 )
      x1( 2 ) = Point1( L1GEOINFx0 )
      y1( 2 ) = Point1( L1GEOINFy0 ) +
     &          Point1( L1GEOINFsy )
      x1( 3 ) = Point1( L1GEOINFx0 ) +
     &          Point1( L1GEOINFsx )
      y1( 3 ) = Point1( L1GEOINFy0 ) +
     &          Point1( L1GEOINFsy )
      x1( 4 ) = Point1( L1GEOINFx0 ) +
     &          Point1( L1GEOINFsx )
      y1( 4 ) = Point1( L1GEOINFy0 )
      z1      = Point1( L1GEOINFz  )

      x2( 1 ) = Point2( L1GEOINFx0 )
      y2( 1 ) = Point2( L1GEOINFy0 )
      x2( 2 ) = Point2( L1GEOINFx0 )
      y2( 2 ) = Point2( L1GEOINFy0 ) +
     &          Point2( L1GEOINFsy )
      x2( 3 ) = Point2( L1GEOINFx0 ) +
     &          Point2( L1GEOINFsx )
      y2( 3 ) = Point2( L1GEOINFy0 ) +
     &          Point2( L1GEOINFsy )
      x2( 4 ) = Point2( L1GEOINFx0 ) +
     &          Point2( L1GEOINFsx )
      y2( 4 ) = Point2( L1GEOINFy0 )
      z2      = Point2( L1GEOINFz  )



      zE      = z

      dZ = z2 - z1

      zFactor = ( z2 - zE ) / dZ

      iPo = 0

      DO iPo1 = 1 , 4
       DO iPo2 = 1 , 4
        iPo = iPo + 1
        xPo(  iPo  ) = x2( iPo2 ) +
     &  ( x1( iPo1 ) - x2( iPo2 ) ) * zFactor
        yPo(  iPo  ) = y2( iPo2 ) +
     &  ( y1( iPo1 ) - y2( iPo2 ) ) * zFactor
       ENDDO
      ENDDO

      xMax = MAX( xPo(  1 ) , xPo(  2 ) ,
     &            xPo(  3 ) , xPo(  4 ) ,
     &            xPo(  5 ) , xPo(  6 ) ,
     &            xPo(  7 ) , xPo(  8 ) ,
     &            xPo(  9 ) , xPo( 10 ) ,
     &            xPo( 11 ) , xPo( 12 ) ,
     &            xPo( 13 ) , xPo( 14 ) ,
     &            xPo( 15 ) , xPo( 16 ) )

      xMin = MIN( xPo(  1 ) , xPo(  2 ) ,
     &            xPo(  3 ) , xPo(  4 ) ,
     &            xPo(  5 ) , xPo(  6 ) ,
     &            xPo(  7 ) , xPo(  8 ) ,
     &            xPo(  9 ) , xPo( 10 ) ,
     &            xPo( 11 ) , xPo( 12 ) ,
     &            xPo( 13 ) , xPo( 14 ) ,
     &            xPo( 15 ) , xPo( 16 ) )

      yMax = MAX( yPo(  1 ) , yPo(  2 ) ,
     &            yPo(  3 ) , yPo(  4 ) ,
     &            yPo(  5 ) , yPo(  6 ) ,
     &            yPo(  7 ) , yPo(  8 ) ,
     &            yPo(  9 ) , yPo( 10 ) ,
     &            yPo( 11 ) , yPo( 12 ) ,
     &            yPo( 13 ) , yPo( 14 ) ,
     &            yPo( 15 ) , yPo( 16 ) )

      yMin = MIN( yPo(  1 ) , yPo(  2 ) ,
     &            yPo(  3 ) , yPo(  4 ) ,
     &            yPo(  5 ) , yPo(  6 ) ,
     &            yPo(  7 ) , yPo(  8 ) ,
     &            yPo(  9 ) , yPo( 10 ) ,
     &            yPo( 11 ) , yPo( 12 ) ,
     &            yPo( 13 ) , yPo( 14 ) ,
     &            yPo( 15 ) , yPo( 16 ) )

      dXdZ = ( x1( 1 ) + x1( 2 ) +
     &         x1( 3 ) + x1( 4 ) ) / 4.0
      dXdZ = ( x2( 1 ) + x2( 2 ) +
     &         x2( 3 ) + x2( 4 ) ) / 4.0
     &         - dXdZ
      dXdZ = dXdZ / dZ
      dYdZ = ( y1( 1 ) + y1( 2 ) +
     &         y1( 3 ) + y1( 4 ) ) / 4.0
      dYdZ = ( y2( 1 ) + y2( 2 ) +
     &         y2( 3 ) + y2( 4 ) ) / 4.0
     &         - dYdZ
      dYdZ = dYdZ / dZ

      ROI1(L1ROIreg+L1GEOINFx0) = xMin
      ROI1(L1ROIreg+L1GEOINFsx) = xMax - xMin
      ROI1(L1ROIreg+L1GEOINFy0) = yMin
      ROI1(L1ROIreg+L1GEOINFsy) = yMax - yMin
      ROI1(L1ROIreg+L1GEOINFz ) = z
      ROI1(L1ROIdxdz) = dXdZ
      ROI1(L1ROIdydz) = dYdZ
      nROI = 1
c
      RETURN
c
      END
