//**********************************************************************/
// Created: 1.10.97  by   Olya Igonkina  for MARPLE package
//
// MARPLE kuip commands
//
//**********************************************************************/

//#ifdef USEKUIP

#include "marple/marple.hh"
extern int MARPLE_SE_SVDNORTRA;
extern int MARPLE_SE_ECALNORTRA;
extern float MARPLE_SEET;

NameRcMatchConst Eparameter;
extern "C" void kugetc_( char*, int *, int );

extern "C"
{
  // shall we use SOFT or STRONG(default) cuts
  void FORTRAN_ROUTINE(marseg )()
  {
    int iLevel;
    FORTRAN_ROUTINE(kugeti)(&iLevel);
    MARPLE_MAKERSEG = iLevel;
    if( iLevel )
      cout << " MARPLE will fill RSEG bank\n";
    else
      cout << " MARPLE will NOT fill RSEG bank\n";
    return;
  }
 // shall we use SOFT or STRONG(default) cuts
  void FORTRAN_ROUTINE(masoft )()
  {
    int iLevel;
    FORTRAN_ROUTINE(kugeti)(&iLevel);
    MARPLE_SOFT = iLevel;
    cout << " MARPLE_SOFT is set to " << MARPLE_SOFT << endl;
    return;
  }

 // set RISE ID in sigmas squared
  void FORTRAN_ROUTINE(marisesig2 )()
  {
    float  tmp;
    FORTRAN_ROUTINE(kugetr)(&tmp);
    MARPLE_RISEID = tmp;
    cout << " MARPLE : RISE ID cut for match set  to " << MARPLE_RISEID <<endl;
    return;
  }

  // set ET threshold for SVD-ECAL match
  void FORTRAN_ROUTINE(maseet )()
  {
    float  tmp;
    FORTRAN_ROUTINE(kugetr)(&tmp);
    MARPLE_SEET = tmp;
    cout << " MARPLE : SVD-ECAL will consider only clusters with Et>" << MARPLE_SEET <<endl;
    return;
  }

  // check if SVD or ECAL is matched with OTR in matchsvdecal
  void FORTRAN_ROUTINE(masenortra )()
  {
    int  tmp;
    FORTRAN_ROUTINE(kugeti)(&tmp);
    MARPLE_SE_SVDNORTRA = tmp;
    FORTRAN_ROUTINE(kugeti)(&tmp);
    MARPLE_SE_ECALNORTRA = tmp;
    if( MARPLE_SE_SVDNORTRA && MARPLE_SE_ECALNORTRA )
      cout << " MATCH SVD-ECAL : consider only Segments and Clusters NOT used in RTRA\n";
    else if(  MARPLE_SE_SVDNORTRA  )
      cout << " MATCH SVD-ECAL : consider Segments NOT used in RTRA and all Clusters\n";
    else if(  MARPLE_SE_ECALNORTRA  )
      cout << " MATCH SVD-ECAL : consider Clusters NOT used in RTRA and all Segments\n";
    else
      cout << " MATCH SVD-ECAL : consider all segments and clusters \n";
    return;
  }

 // interested in background? mixed events?
  void FORTRAN_ROUTINE(mabkgr )()
  {
    int iLevel;
    FORTRAN_ROUTINE(kugeti)(&iLevel);
    MARPLE_BKGR = iLevel;
    cout << " MARPLE_BKGR is set to " << MARPLE_BKGR << endl;
    return;
  }
  // set printout level
  void FORTRAN_ROUTINE(madebug )()
  {
    int iLevel;
    FORTRAN_ROUTINE(kugeti)(&iLevel);
    MARPLE_DEBUG = iLevel;
    return;
  }
  //************************************************************/
  // set all constants
  void FORTRAN_ROUTINE(maall_read )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	  Eparameter = Eall;
	  ptRcConst->read( Eparameter );
	  return;
    }
  //************************************************************/
  // show all constants
  void FORTRAN_ROUTINE(maall_show )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
      cout << *ptRcConst << endl;

    }
  //************************************************************/
  // set chi2 value
  void FORTRAN_ROUTINE(machi2 )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Echi2;
	(*ptRcConst).read( Eparameter );
    }
  //************************************************************/
  //set constants for DELTAS cut 
  void FORTRAN_ROUTINE(madeltas )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Edelta_x;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_y;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_tx;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_ty;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_pe;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Echi2;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Euse_delta_cut ;
	(*ptRcConst).read( Eparameter  );
    }

  //************************************************************/
  //set constants for PAIR_cut
  void FORTRAN_ROUTINE(mapair_cut )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Euse_pair_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter =En_pair_left;
	(*ptRcConst).read( Eparameter  );
	Eparameter =En_pair_right;
	(*ptRcConst).read( Eparameter  );
    }

  //************************************************************/
  //set which cuts should be used
  void FORTRAN_ROUTINE(macuts )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Euse_pair_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Euse_delta_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Eflag;
	(*ptRcConst).read( Eparameter  );
    }
}

//#elseif

//#endif


