
* B.Fominykh  15.06.98
* the program of the MUREC-B package
* calculates the error due to multiple scattering and 
* the momenta inside the muon superlayers in the case of seed IS,
* saves the calculated values to the temporary seed table MUSD
*
      SUBROUTINE MURMSCB(IS)
C-    ======================
* input: IS - #seed
*
      IMPLICIT NONE
*
#include "murec/MUCBZDT.fi"
#include "murec/MUCBTAB.fi"
#include "murec/MUCONT.fi"
#include "arte/Arte.fi"
#include "auto/GWAL.fi"
#include "auto/GCAL.fi"
#include "auto/GESL.fi"
#include "auto/GMAT.fi"
      INTEGER IS,JS,MSLC,LR,LRC,MUSL,IW,JW,IMAT,JMAT,I,J,NMSLMN
      REAL P,PM,DEDX,Z0,CX,CY,TX,TY,ZW,ZW1,ZW2,XW1,XW2,YW1,YW2
      REAL SS,ZS,XS,YS,XSD,YSD,DENS,RHO,RADL,X,THET,XW,YW
      REAL XIP,YIP,XIPD,YIPD,XOP,YOP,XOPD,YOPD,COSR,SINR
      REAL ERMS(4),DERMS(4),PS(4),ZMSL(4)
#include "arte/Arte.ff"
#include "auto/GWAL.ff"
C*     -------------------------------
* check-point
      IF(JTMP6.LE.0)        GOTO 200
      IF(IQ(JTMP6+1).LE.0)  GOTO 200
      IF(IQ(JTMP6+2).LE.0)  GOTO 200
      IF(IS.LE.0)           GOTO 200
      IF(IS.GT.IQ(JTMP6+2)) GOTO 200
      JS=JTMP6+IQ(JTMP6+1)*(IS-1)+2
      DO I=26,36
        Q(JS+I)=0.
      ENDDO
      IF(JGWAL.LE.0)        GOTO 200
      IF(IQ(JGWAL+1).LE.0)  GOTO 200
      IF(IQ(JGWAL+2).LE.0)  GOTO 200
      IF(JGCAL.LE.0)        GOTO 200
      IF(IQ(JGCAL+1).LE.0)  GOTO 200
      IF(IQ(JGCAL+2).LE.0)  GOTO 200
*
      PM= Q(JS+4)
      P = PM
* dE/dX for muons
      DEDX=0.0025
*
      DO I=1,4
        ERMS(I) =0.
        DERMS(I)=0.
        PS(I)   =0.
      ENDDO
* track parameters
      Z0=Q(JS+5)
      CX=Q(JS+6)
      CY=Q(JS+7)
      TX=Q(JS+8)
      TY=Q(JS+9)
* z-coordinates of muon superlayers
      MSLC=1
      DO 20 LR=1,NMRLAY
        IF(MUSLDT(LR).EQ.MSLC.AND.LR.LT.NMRLAY) GOTO 20
        MSLC=MUSLDT(LR)
        LRC=LR
        IF(LR.LT.NMRLAY) LRC=LRC-1
        MUSL=MUSLDT(LRC)
        ZMSL(MUSL)=ZMUDT2(LRC)
  20  CONTINUE
* min superlayer of muon detector
      NMSLMN=0
      DO 80 I=1,IQ(JGESL+2)
        JW=JGESL+IQ(JGESL+1)*(I-1)+2
        IF(IQ(JW+JGESL_CMP).NE.8) GOTO 80
        NMSLMN=I-1
        GOTO 81
  80  CONTINUE
  81  IF(NMSLMN.EQ.0) GOTO 200
*
      IF(IPRSC.GT.3)
     + PRINT 1001,IS,PM,Z0,(ZMSL(J),J=1,4),NMSLMN
      IF(IPRLG.GT.3)
     + WRITE(LLOGF,1001) IS,PM,Z0,(ZMSL(J),J=1,4),NMSLMN
 1001 FORMAT(2X,'MURMSC: seed',I3,' Pm,Z0:',F7.2,F7.1,
     +         ' Zsl',4F7.1,' SL',I3)
*
* calorimeter
      DO 50 IW=1,IQ(JGCAL+2)
        JW=JGCAL+IQ(JGCAL+1)*(IW-1)+2
* input point
        ZW1=Q(JW+JGCAL_ZMIN)
        XIP=TX*(ZW1-Z0)+CX
        YIP=TY*(ZW1-Z0)+CY
* output point
        ZW2=Q(JW+JGCAL_ZMAX)
        XOP=TX*(ZW2-Z0)+CX
        YOP=TY*(ZW2-Z0)+CY
        XW1=Q(JW+JGCAL_XMIN)
        IF(XIP.LT.XW1.AND.XOP.LT.XW1) GOTO 50
        XW2=Q(JW+JGCAL_XMAX)
        IF(XIP.GT.XW2.AND.XOP.GT.XW2) GOTO 50
        YW1=Q(JW+JGCAL_YMIN)
        IF(YIP.LT.YW1.AND.YOP.LT.YW1) GOTO 50
        YW2=Q(JW+JGCAL_YMAX)
        IF(YIP.GT.YW2.AND.YOP.GT.YW2) GOTO 50
* the length of trace inside box
        SS=0.
* the case of maximal length
        IF(XIP.GE.XW1.AND.XOP.GE.XW1.AND.
     +     XIP.LE.XW2.AND.XOP.LE.XW2.AND.
     +     YIP.GE.YW1.AND.YOP.GE.YW1.AND.
     +     YIP.LE.YW2.AND.YOP.LE.YW2) THEN
          SS=SQRT((XIP-XOP)**2+(YIP-YOP)**2+(ZW1-ZW2)**2)
          IF(IPRLG.GT.3)
     +    WRITE(LLOGF,*) 
     +    'case 1:',SS,XW1,XIP,XOP,XW2,YW1,YIP,YOP,YW2
          GOTO 30
        ENDIF
* the case when the particle outgos through the side plane of box 
        IF(XIP.GE.XW1.AND.XIP.LE.XW2.AND.
     +     YIP.GE.YW1.AND.YIP.LE.YW2) THEN
          IF(XOP.LT.XW1.OR.XOP.GT.XW2) THEN
            IF(XOP.LT.XW1) XW=XW1
            IF(XOP.GT.XW2) XW=XW2
            ZS=ZW1+(ZW2-ZW1)/(XOP-XIP)*(XW-XIP)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            IF(YS.GE.YW1.AND.YS.LE.YW2) GOTO 22
          ENDIF
          IF(YOP.LT.YW1.OR.YOP.GT.YW2) THEN
            IF(YOP.LT.YW1) YW=YW1
            IF(YOP.GT.YW2) YW=YW2
            ZS=ZW1+(ZW2-ZW1)/(YOP-YIP)*(YW-YIP)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            IF(XS.GE.XW1.AND.XS.LE.XW2) GOTO 22
          ENDIF
          PRINT*,'MURMSC: creazy check #11'
          GOTO 30
  22      CONTINUE
          SS=SQRT((XIP-XS)**2+(YIP-YS)**2+(ZW1-ZS)**2)
          IF(IPRLG.GT.3)
     +    WRITE(LLOGF,*) 
     +    'case 2:',SS,ZW1,ZS,ZW2,XW1,XS,XW2,YW1,YS,YW2
          GOTO 30
        ENDIF
* the case when the particle incomes through the side plane of box 
        IF(XOP.GE.XW1.AND.XOP.LE.XW2.AND.
     +     YOP.GE.YW1.AND.YOP.LE.YW2) THEN
          IF(XIP.LT.XW1.OR.XIP.GT.XW2) THEN
            IF(XIP.LT.XW1) XW=XW1
            IF(XIP.GT.XW2) XW=XW2
            ZS=ZW1+(ZW2-ZW1)/(XOP-XIP)*(XW-XIP)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            IF(YS.GE.YW1.AND.YS.LE.YW2) GOTO 25
          ENDIF
          IF(YIP.LT.YW1.OR.YIP.GT.YW2) THEN
            IF(YIP.LT.YW1) YW=YW1
            IF(YIP.GT.YW2) YW=YW2
            ZS=ZW1+(ZW2-ZW1)/(YOP-YIP)*(YW-YIP)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            IF(XS.GE.XW1.AND.XS.LE.XW2) GOTO 25
          ENDIF
          PRINT*,'MURMSC: creazy check #12'
          GOTO 30
  25      CONTINUE
          SS=SQRT((XOP-XS)**2+(YOP-YS)**2+(ZW2-ZS)**2)
          IF(IPRLG.GT.3)
     +    WRITE(LLOGF,*) 
     +    'case 3:',SS,ZW1,ZS,ZW2,XW1,XS,XW2,YW1,YS,YW2
          GOTO 30
        ENDIF
  30    CONTINUE
        IF(SS.LE.0.) GOTO 50
* relation to material
        IMAT=IQ(JW+JGCAL_GMAT)
        JMAT=JGMAT+IQ(JGMAT+1)*(IMAT-1)+2
        DENS=Q(JMAT+JGMAT_DENS)
        RHO=DENS*SS
        P=P-DEDX*RHO
        IF(P.GT.0.) THEN
          RADL=Q(JMAT+JGMAT_RADL)
          X=SS/RADL
          THET=13.6/1000./P*SQRT(X)*(1.+0.038*ALOG(X))
          ZW=0.5*(ZW1+ZW2)
          IF(IPRLG.GT.3)
     +    WRITE(LLOGF,1002) IW,ZW1,ZW2,
     +             P,IMAT,DENS,RADL,X,THET
 1002   FORMAT(2X,'calo block',I4,' z1,2',2F7.1,' p',F7.2,
     +      /,10X,'mat,dens,radl',I3,2F5.2,' X,THET',2E12.6)

          DO I=1,4
***              ERMS(I)=ERMS(I)+((ZMSL(I)-ZW)*THET)**2/3.
              ERMS(I)=ERMS(I)+((ZMSL(I)-ZW)*THET)**2
              PS(I)=P
          ENDDO
        ELSE
          DO I=1,4
              ERMS(I)=0.
              PS(I)=0.
          ENDDO
          GOTO 60
        ENDIF
 50   CONTINUE
 60   CONTINUE
*
      IF(IPRSC.GT.3)
     + PRINT 1003,(ERMS(J),DERMS(J),PS(J),J=1,4)
      IF(IPRLG.GT.3)
     + WRITE(LLOGF,1003) (ERMS(J),DERMS(J),PS(J),J=1,4)
* check-point
      DO I=1,4
        IF(ERMS(I).GT.0.) GOTO 70
      ENDDO
      GOTO 170
*
 70   CONTINUE
* loops over walls
      JW=JGWAL-IQ(JGWAL+1)+2
      DO 150 IW=1,IQ(JGWAL+2)
        JW=JW+IQ(JGWAL+1)
* only muon walls
        IF(IQ(JW+JGWAL_GESL).LT.NMSLMN) GOTO 150
        ZW1=Q(JW+JGWAL_ZMIN)
        IF(ZW1.LT.Z0) GOTO 150
* only boxes
        IF(IQ(JW+JGWAL_SHP).NE.1) GOTO 150
        IF(ZW1.GT.ZMSL(4)) GOTO 160
* input point
        XIP=TX*(ZW1-Z0)+CX
        YIP=TY*(ZW1-Z0)+CY
* output point
        ZW2=Q(JW+JGWAL_ZMAX)
        XOP=TX*(ZW2-Z0)+CX
        YOP=TY*(ZW2-Z0)+CY
* sin,cos of wall rotation angle
        COSR=FGWAL_ROT(1,IW)
        SINR=FGWAL_ROT(2,IW)
* rotate the input and output points to wall system
        XIPD=XIP*COSR-YIP*SINR
        XOPD=XOP*COSR-YOP*SINR
        XW1=Q(JW+JGWAL_XMIN)
        IF(XIPD.LT.XW1.AND.XOPD.LT.XW1) GOTO 150
        XW2=Q(JW+JGWAL_XMAX)
        IF(XIPD.GT.XW2.AND.XOPD.GT.XW2) GOTO 150

        YIPD=XIP*SINR+YIP*COSR
        YOPD=XOP*SINR+YOP*COSR
        YW1=Q(JW+JGWAL_YMIN)
        IF(YIPD.LT.YW1.AND.YOPD.LT.YW1) GOTO 150
        YW2=Q(JW+JGWAL_YMAX)
        IF(YIPD.GT.YW2.AND.YOPD.GT.YW2) GOTO 150
* the length of trace inside box
        SS=0.
* the case of maximal length
        IF(XIPD.GE.XW1.AND.XOPD.GE.XW1.AND.
     +     XIPD.LE.XW2.AND.XOPD.LE.XW2.AND.
     +     YIPD.GE.YW1.AND.YOPD.GE.YW1.AND.
     +     YIPD.LE.YW2.AND.YOPD.LE.YW2) THEN
          SS=SQRT((XIPD-XOPD)**2+(YIPD-YOPD)**2+(ZW1-ZW2)**2)
          GOTO 130
        ENDIF
* the case when the particle outgos through the side plane of box 
        IF(XIPD.GE.XW1.AND.XIPD.LE.XW2.AND.
     +     YIPD.GE.YW1.AND.YIPD.LE.YW2) THEN
          IF(XOPD.LT.XW1.OR.XOPD.GT.XW2) THEN
            IF(XOPD.LT.XW1) XW=XW1
            IF(XOPD.GT.XW2) XW=XW2
            ZS=ZW1+(ZW2-ZW1)/(XOPD-XIPD)*(XW-XIPD)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            XSD=XS*COSR-YS*SINR
            YSD=XS*SINR+YS*COSR
            IF(YSD.GE.YW1.AND.YSD.LE.YW2) GOTO 120
          ENDIF
          IF(YOPD.LT.YW1.OR.YOPD.GT.YW2) THEN
            IF(YOPD.LT.YW1) YW=YW1
            IF(YOPD.GT.YW2) YW=YW2
            ZS=ZW1+(ZW2-ZW1)/(YOPD-YIPD)*(YW-YIPD)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            XSD=XS*COSR-YS*SINR
            YSD=XS*SINR+YS*COSR
            IF(XSD.GE.XW1.AND.XSD.LE.XW2) GOTO 120
          ENDIF
          PRINT*,'MURMSC: creazy check #21'
          GOTO 130
  120     CONTINUE
          SS=SQRT((XIPD-XSD)**2+(YIPD-YSD)**2+(ZW1-ZS)**2)
          GOTO 130
        ENDIF
* the case when the particle incomes through the side plane of box 
        IF(XOPD.GE.XW1.AND.XOPD.LE.XW2.AND.
     +     YOPD.GE.YW1.AND.YOPD.LE.YW2) THEN
          IF(XIPD.LT.XW1.OR.XIPD.GT.XW2) THEN
            IF(XIPD.LT.XW1) XW=XW1
            IF(XIPD.GT.XW2) XW=XW2
            ZS=ZW1+(ZW2-ZW1)/(XOPD-XIPD)*(XW-XIPD)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            XSD=XS*COSR-YS*SINR
            YSD=XS*SINR+YS*COSR
            IF(YSD.GE.YW1.AND.YSD.LE.YW2) GOTO 125
          ENDIF
          IF(YIPD.LT.YW1.OR.YIPD.GT.YW2) THEN
            IF(YIPD.LT.YW1) YW=YW1
            IF(YIPD.GT.YW2) YW=YW2
            ZS=ZW1+(ZW2-ZW1)/(YOPD-YIPD)*(YW-YIPD)
            XS=TX*(ZS-Z0)+CX
            YS=TY*(ZS-Z0)+CY
            XSD=XS*COSR-YS*SINR
            YSD=XS*SINR+YS*COSR
            IF(XSD.GE.XW1.AND.XSD.LE.XW2) GOTO 125
          ENDIF
          GOTO 130
  125     CONTINUE
          SS=SQRT((XOPD-XSD)**2+(YOPD-YSD)**2+(ZW2-ZS)**2)
          GOTO 130
        ENDIF
  130   CONTINUE
        IF(SS.LE.0.) GOTO 150
* relation to material
        IMAT=IQ(JW+JGWAL_GMAT)
        JMAT=JGMAT+IQ(JGMAT+1)*(IMAT-1)+2
        DENS=Q(JMAT+JGMAT_DENS)
        RHO=DENS*SS
        P=P-DEDX*RHO
        IF(P.GT.0.) THEN
          RADL=Q(JMAT+JGMAT_RADL)
          X=SS/RADL
          THET=13.6/1000./P*SQRT(X)*(1.+0.038*ALOG(X))
          ZW=0.5*(ZW1+ZW2)
*
        IF(IPRLG.GT.3)
     +   WRITE(LLOGF,1004) IW,IQ(JW+JGWAL_GESL),ZW1,ZW2,
     +             P,IMAT,DENS,RADL,X,THET
 1004   FORMAT(2X,'wall,SL',2I4,' z1,2',2F7.1,' p',F7.2,
     +      /,10X,'mat,dens,radl',I3,2F5.2,' X,THET',2E12.6)

          DO I=1,4
            IF(ZW2.LT.ZMSL(I)) THEN
              ERMS(I)=ERMS(I)+((ZMSL(I)-ZW)*THET)**2/3.
              PS(I)=P
              IF(I.GT.1.AND.ZW1.GT.ZMSL(I-1))
     +        DERMS(I)=DERMS(I)+((ZMSL(I)-ZW)*THET)**2/3.
            ENDIF
          ENDDO
        ELSE
          DO I=1,4
            IF(ZW2.LT.ZMSL(I)) THEN
              ERMS(I)=0.
              DERMS(I)=0.
              PS(I)=0.
            ENDIF
          ENDDO
          GOTO 160
        ENDIF
 150  CONTINUE
 160  CONTINUE
* save calculated values
*
      IF(IPRSC.GT.3)
     + PRINT 1003,(ERMS(J),DERMS(J),PS(J),J=1,4)
      IF(IPRLG.GT.3)
     + WRITE(LLOGF,1003) (ERMS(J),DERMS(J),PS(J),J=1,4)
 1003 FORMAT(3X,'ER,DER,P:',2(2E12.6,F8.3,4X),/,12X,2(2E12.6,F8.3,4X))
*
  170 CONTINUE
      DO 180 I=1,4
      Q(JS+I+32)=PS(I)
      IF(I.EQ.1) THEN
        Q(JS+26)=SQRT(ERMS(I))
      ELSE
        Q(JS+23+2*I)=SQRT(ERMS(I))
        Q(JS+24+2*I)=SQRT(DERMS(I))
      ENDIF      
  180 CONTINUE
*
  200 CONTINUE
      RETURN
      END
