
* B.Fominykh  2.04.2000
* the program of MuonID package
* make seeds from RTRA tracks to start the muon identification,
* cuts: seeds have to pass through MU1 and to have momenta more PSDCUT

* bug correction 18.07.2000 by B.Fominykh
* bug correction 23.01.2001 by B.Fominykh
C
      SUBROUTINE MURSDIN
C-    ==================
      IMPLICIT NONE
      INTEGER IR,JR,JRR,NS,JSD,IS,IST,JSHM,NML
      INTEGER IMC,JMC,I,J,ISL,JSL,IRT,JT,JAUX,NRTR,JT1
      REAL P,PM,PX,PY,PZ
      REAL X1,X2,Y1,Y2,Z1,Z2,Z0,CX,CY,TX,TY,XE,YE
*
*     **** packing scheme for covariance
      integer matrix_pack(5,5)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
*
#include "murec/MUCBTAB.fi"
      REAL PSD(NSDMXP)
#include "murec/MUCBPAR.fi"
#include "murec/MUCBZDT.fi"
#include "arte/Arte.fi"
#include "arte/RSEG_cmp.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
* CHECK-POINT 1: no reconstructed tracks - nothing to do
      IF(JRTRA.LE.0)       GOTO 200
      IF(IQ(JRTRA+2).LE.0) GOTO 200
      IF(JRSEG.LE.0)       GOTO 200
      IF(IQ(JRSEG+2).LE.0) GOTO 200
* get boundaries of MU1 as cuts for check-point 3
      JSL=JGESL+2
      DO ISL=1,IQ(JGESL+2)
        IF(IQ(JSL+JGESL_CMP).EQ.8) THEN
          X1=Q(JSL+JGESL_X1)
          X2=Q(JSL+JGESL_X2)
          Y1=Q(JSL+JGESL_Y1)
          Y2=Q(JSL+JGESL_Y2)
          Z1=Q(JSL+JGESL_Z1)
          Z2=Q(JSL+JGESL_Z2)
          GOTO 5
        ELSE
          JSL=JSL+IQ(JGESL+1)
        ENDIF
      ENDDO
  5   CONTINUE

* loops over RTRA tracks
      NS=0
      DO 150 IRT=1,IQ(JRTRA+2)
        JT=JRTRA+IQ(JRTRA+1)*(IRT-1)+2
* set muon flag in RTRA track
        IQ(JT+JRTRA_FLM)=0
*
* CHECK-POINT 2: cut on  momentum taken from RTRA
        PM=250.
        IF(ABS(Q(JT+JRTRA_PF)).GT.0.004) PM=1./ABS(Q(JT+JRTRA_PF))
        IF(PM.LT.PSDCUT) THEN
          IQ(JT+JRTRA_FLM)=-1
          GOTO 150
        ENDIF
*

* use relations RTRA_RSEG to find OTR pattern segment  
        JAUX=PRTRA_RSEG(IRT)
        IS=0
 11     IF(JAUX.EQ.0) GOTO 13
* pointer to RSEG
        I=MRTRA_RSEG(JAUX)
* not take the killed segments
        IF(IAND(irseg_cmp(I),rsegc_bitsign).EQ.0) THEN
***          IF(IAND(irseg_cmp(I),rsegc_magt).NE.0).AND.
          IF(IAND(irseg_cmp(I),rsegc_patt).NE.0) THEN
            IS=I
            GOTO 13
          ENDIF
        ENDIF
        JAUX=XRTRA_RSEG(JAUX)
        GOTO 11
 13     CONTINUE
        IF(IS.LE.0) THEN
          IQ(JT+JRTRA_FLM)=0
          GOTO 150
        ENDIF
*

* use relation RSEG_REND to find TC segment
        IST=0
        JAUX=PRSEG_REND(IS)
  21    IF(JAUX.EQ.0) GOTO 23
        IST=MRSEG_REND(JAUX)
        IF(IAND(irseg_cmp(IST),rsegc_bitsign).EQ.0) THEN
          IF(IAND(irseg_cmp(IST),rsegc_trit).NE.0) GOTO 23
        ENDIF
        JAUX=XRSEG_REND(JAUX)
        GOTO 21
  23    CONTINUE

* which segment to use for extrapolation
        IF(IST.GT.0) THEN
          IQ(JT+JRTRA_FLM)=10
          IR=IST
        ELSE
          IR=IS
        ENDIF
        JR=JRSEG+IQ(JRSEG+1)*(IR-1)+2

* CHECK-POINT 3: impact point inside first muon superlayer
        Z0 = Q(JR+JRSEG_ZE)
        CX = Q(JR+JRSEG_XE)
        TX = Q(JR+JRSEG_TXE)
        XE = TX*(Z2-Z0)+CX
        CY = Q(JR+JRSEG_YE)
        TY = Q(JR+JRSEG_TYE)
        YE = TY*(Z2-Z0)+CY

        IF(XE.LT.X1.OR.XE.GT.X2.OR.
     +     YE.LT.Y1.OR.YE.GT.Y2) THEN
          IF(IQ(JT+JRTRA_FLM).EQ.10) THEN
            IQ(JT+JRTRA_FLM)=-13
          ELSE
            IQ(JT+JRTRA_FLM)=-3
          ENDIF
          GOTO 150
        ENDIF

* bug correction 18.07.2000 by B.Fominykh
* cut on number of seeds
        IF(NS.GE.NSDMXP-1) GOTO 150

* is the segment used first time as a seed?
        IF(NS.GT.0) THEN
          DO I=1,NS
            JSD=JTMP6+IQ(JTMP6+1)*(I-1)+2
            IF(IQ(JSD+3).EQ.IR) THEN

* bug correction 23.01.2001 by B.Fominykh
* no more 9 RTRAs in the list
              IF(IQ(JSD+79).GE.9) GOTO 150

* add RTRA to the seed list 
              NRTR=IQ(JSD+79)+1
              IQ(JSD+NRTR+79)=IRT
              IQ(JSD+79)=NRTR
* update the flag
              JT1=JRTRA+IQ(JRTRA+1)*(IQ(JSD+80)-1)+2
              IQ(JT+JRTRA_FLM)=IQ(JT1+JRTRA_FLM)
              GOTO 150
            ENDIF
          ENDDO
        ENDIF
* make a new seed
        NS=NS+1
        IF(NS.GT.IQ(JTMP6+2)) CALL MMBOOK(JTMP6,1)
        JSD=JTMP6+IQ(JTMP6+1)*(NS-1)+2
        IQ(JSD+1) = 0
        IQ(JSD+2) = 0
        IQ(JSD+3) = IR
        IQ(JSD+79)= 1
        IQ(JSD+80)= IRT
        Q(JSD+4)  = PM
* start Z coordinate
        Q(JSD+44) = Q(JR+JRSEG_ZF)
* an array for order
        ISDORD(NS)=NS
        PSD(NS)=PM
* TC segments have larger priority
        IF(IST.LE.0)  PSD(NS)=PM/1000.
* track parameters at the end of track
        Q(JSD+5) = Z0
        Q(JSD+6) = CX
        Q(JSD+7) = CY
        Q(JSD+8) = TX
        Q(JSD+9) = TY
* covariance
        JRR=JR+JRSEG_CVE-1
        DO I=1,4
          DO J=1,4
            Q(JSD+4*I+J+5) = Q(JRR+matrix_pack(I,J))
          ENDDO
        ENDDO

* errors of multiple scattering and momenta inside superlayers
        CALL MURMSCB(NS)
* kill the stopped tracks
        DO I=1,4
          IF(Q(JSD+32+I).LE.0.001) THEN
            IF(IQ(JT+JRTRA_FLM).EQ.10) THEN
              IQ(JT+JRTRA_FLM)=-12
            ELSE
              IQ(JT+JRTRA_FLM)=-2
            ENDIF
            GOTO 149
          ENDIF
        ENDDO
* predicted hit-map
        DO I=1,12
          IQ(JSD+I+44)=0
        ENDDO
        CALL MURSHM(NS)
        JSHM=JSD+44
* hit-map control
        NML=0
        DO I=1,12
          IF(IQ(JSHM+I).GT.0) NML=NML+1
        ENDDO
        IF(NML.LT.3) THEN
          IF(IQ(JT+JRTRA_FLM).EQ.10) THEN
            IQ(JT+JRTRA_FLM)=-14
          ELSE
            IQ(JT+JRTRA_FLM)=-4
          ENDIF
          GOTO 149
        ENDIF
* +1 to muon flag in RTRA track
        IQ(JT+JRTRA_FLM)=IQ(JT+JRTRA_FLM)+1
*
* relation to MC track
        IQ(JSD+37) = 0
        IQ(JSD+38) = 0
        DO J=39,42
          Q(JSD+J) = 0.
        ENDDO
* check that it is MC
        IF(JMTRA.LE.0)       GOTO 150
        IF(IQ(JMTRA+2).LE.0) GOTO 150
        IF(IQ(JMTRA+1).LE.0) GOTO 150
* related MC track
        IMC=0
        JAUX=PRTRA_MTRA(IRT)
 31     CONTINUE
        IF(JAUX.LE.0) GOTO 33
        IMC=MRTRA_MTRA(JAUX)

        JAUX=XRTRA_MTRA(JAUX)
        GOTO 31
 33     CONTINUE
        IF(IMC.LE.0) GOTO 150

* MC-track number
        IQ(JSD+37) = IMC
        JMC=JMTRA+IQ(JMTRA+1)*(IMC-1)+2
* ID of MC-track
        IQ(JSD+38) = IQ(JMC+JMTRA_TOPP)
* MC-track momentum
        PX=Q(JMC+JMTRA_PX)
        PY=Q(JMC+JMTRA_PY)
        PZ=Q(JMC+JMTRA_PZ)
        P=SQRT(PX*PX+PY*PY+PZ*PZ)
        Q(JSD+39) = P
        Q(JSD+40) = PX
        Q(JSD+41) = PY
        Q(JSD+42) = PZ
        GOTO 150
*
 149    CONTINUE
        NS=NS-1
 150  CONTINUE

* sort the seeds using momenta
      IF(NS.GT.1) CALL SORTZV(PSD,ISDORD,NS,1,1,0)
      DO 160 J=1,NS
        JSD=JTMP6+IQ(JTMP6+1)*(ISDORD(J)-1)+2
        IQ(JSD+43) = J
 160  CONTINUE
*
 200  CONTINUE
      RETURN
      END


