
*  B.Fominykh  23.04.2000
*  the program of MuonID package
*  calculates the space point coordinates from wires in MU1, MU2
*  and the space point likelihood
*
*  input:  NCL      - number of clusters
*          LCL(NCL) - list of clusters
*          ISD      - # seed
*          IPR      - print control
*  otput:  XP(6)    - x,y,z,sigx**2,sigy**2,cor*sigx*sigy of space point
*          LHS      - shape likelyhood
*
*  updated 05.01.2001 by B.Fominykh - tune the parameters
*
*
      SUBROUTINE MURSPT(NCL,LCL,ISD,IPR,XP,LHS)
C-    =========================================
      IMPLICIT NONE
      INTEGER IPR,NCL,LCL(1),IC,JC,ISD,JSD,I,NCW
      REAL XP(6),LHS,XD(6),RES(6),TX,TY,XF,YF,ZF,SGX,SGY,COR
      REAL SN(6),CN(6),DX(6),DY(6),ERX(6),LH,SX,SY,CR
      REAL ERCUT,EFF,UNEFF1,UNEFF2
***      DATA ERCUT /1./,EFF /1./,UNEFF1 /0.1/,UNEFF2 /0.1/ 
      DATA ERCUT /2./,EFF /1./,UNEFF1 /0.3/,UNEFF2 /0.3/ 
      double precision A1,A2,B1,B2,C1,C2,DD

#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      DO I=1,6
        XP(I)=0.
      ENDDO
***      LHS=-1.
      LHS=-6.*ALOG(UNEFF1)
***      IF(NCL.LT.3) RETURN
      IF(NCL.LT.2) RETURN

* take a slope of seed
      IF(JTMP6.LE.0)       GOTO 999
      IF(IQ(JTMP6+1).LE.0) GOTO 999
      IF(ISD.LE.0.OR.ISD.GT.IQ(JTMP6+2)) GOTO 999
      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
      TX=Q(JSD+8)
      TY=Q(JSD+9)
      XF=0.
      YF=0.
      ZF=0.

* clusters
      IF(JTMP8.LE.0)       GOTO 999
      IF(IQ(JTMP8+1).LE.0) GOTO 999
      IF(IQ(JTMP8+2).LT.3) GOTO 999
      IC=LCL(1)
      IF(IC.LE.0.OR.IC.GT.IQ(JTMP8+2)) GOTO 999
      JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
      ZF=Q(JC+6)
      DO I=1,NCL
        IC=LCL(I)
        IF(IC.LE.0.OR.IC.GT.IQ(JTMP8+2)) GOTO 999
        JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
        XD(I)=Q(JC+8)
        SN(I)=Q(JC+7)
        CN(I)=SQRT(1.-SN(I)*SN(I))
        DX(I)=TX*(Q(JC+6)-ZF)
        DY(I)=TY*(Q(JC+6)-ZF)
        ERX(I)=Q(JC+11)**2
      ENDDO

***        PRINT 2001,NCL,(XD(I),SN(I),CN(I),I=1,NCL)
*** 2001   FORMAT(1X,'Ncl',I2,' d,s,c:',6(F8.2,2F6.2,2X))

* calculate the space point coordinates
      A1=0.
       B1=0.
        C1=0.
         A2=0.
          C2=0.
      NCW=0
      DO I=1,NCL
        IF(ERX(I).LT.ERCUT) THEN
          NCW=NCW+1
          A1=A1+XD(I)*CN(I)-DX(I)*CN(I)**2+DY(I)*SN(I)*CN(I)
          B1=B1+CN(I)**2
          C1=C1+SN(I)*CN(I)
          A2=A2+XD(I)*SN(I)-DX(I)*SN(I)*CN(I)+DY(I)*SN(I)**2
          C2=C2+SN(I)**2
        ENDIF
      ENDDO 
***      IF(NCW.LT.3) GOTO 999
      IF(NCW.LT.2) GOTO 999
      B2=C1
      DD=B1*C2-B2*C1

***        PRINT 2003,A1,A2,B1,B2,C1,C2,DD
*** 2003   FORMAT(1X,'A1,A2',2E12.4,' B1,B2',2E12.4,
***     +          /,' C1,C2',2E12.4,' DD',E12.4)

      IF(DABS(DD).GT.1.E-15) THEN
        XF=(A1*C2-A2*C1)/DD
        YF=(A1*B2-A2*B1)/DD
        SGX=C2/DD
        SGY=B1/DD
        COR =-C1/DD
      ELSE
        GOTO 999
      ENDIF

      IF(IPR.GT.0) THEN
        IF(SGX.GE.0.) SX=SQRT(SGX)
        IF(SGY.GE.0.) SY=SQRT(SGY)
        IF(SGY.GE.1.E-4.AND.SGY.GE.1.E-4) CR=COR/SGX/SGY
        PRINT 2002,A1,A2,B1,B2,C1,C2,DD,XF,YF,
     +             SX,SY,CR,SGX,SGY,COR
 2002   FORMAT(1X,'A1,A2',2E12.4,' B1,B2',2E12.4,' C1,C2',
     +   2E12.4,/,' DD',E12.4,' XF,YF',2F8.2,
     +   ' SX,SY,CR',2F7.2,F7.3,/,' cov',3E12.4)
      ENDIF

* shape likelyhood
      LH=-FLOAT(NCL)*ALOG(EFF)-FLOAT(6-NCL)*ALOG(UNEFF1)

* contribution of residuals into shape likelyhood
      DO I=1,NCL
        RES(I)=XD(I)-(XF+DX(I))*CN(I)+(YF+DY(I))*SN(I)
        IF(RES(I)**2.GT.4.*ERX(I)) LH=LH-ALOG(UNEFF2)
***        IF(RES(I)**2.GT.4.*ERX(I)) LH=LH+RES(I)**2/2./ERX(I)
      ENDDO
      XP(1)=XF
       XP(2)=YF
        XP(3)=ZF
         XP(4)=SGX
          XP(5)=SGY
           XP(6)=COR
      LHS  =LH

 999  CONTINUE
      IF(IPR.GT.0.AND.NCL.GT.0) THEN
        PRINT 1001,NCL,(XP(I),I=1,6),LHS
 1001   FORMAT(1X,'Ncl',I2,' X,Y',2F9.2,' Z',F10.2,
     +            ' cov',3E12.4,' LHS',E12.4)
        PRINT 1002,(RES(I),2.*SQRT(ERX(I)),I=1,NCL)
 1002   FORMAT(1X,'res,2*erx:',6(F6.2,F5.2,2X))
      ENDIF

*
      RETURN
      END




