*
*  B.Fominykh  21.06.98
*  the program of MUREC-B package
*  estimates the seed-branch coupling quality -> cuts and estimator
*  input:  IBRS - start branch number
*          IBRF - final branch number
*
      SUBROUTINE MURTRQU(IBRS,IBRF)
C-    =============================
      IMPLICIT NONE
#include "murec/MUCBTAB.fi"
#include "murec/MUCBPAR.fi"
      INTEGER IBR,IBRS,IBRF,JBR,ISD,JSD,IH,JH,IHT,JHT,MUSL,JSDM
      INTEGER I,NHIS,IHTR,IND(4,3),J
      INTEGER NHITI,NHOLI,NHITO,NHOLO,NHIT,NHOL
      INTEGER JSDHM,JBRHM
      REAL CHIS,CHIKF,SINR,COSR,DSD,SIG2,SIGX2,SIGY2,EST1,ERMS
      REAL DIST,RHOL
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      DO 100 IBR=IBRS,IBRF
        JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* cut on number of collected hits
        IF(IQ(JBR+8).LT.3) GOTO 99
* kill the branches with chi**2/Nhit > CHITRM=50. 
        CHIKF=Q(JBR+22)/REAL(IQ(JBR+8))
        IF(CHIKF.GT.CHITRM) GOTO 99

* pointer to hit-map
        JBRHM=JBR+8
        ISD=IQ(JBR+4)
        JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
        JSDHM=JSD+44
* calculate the number of holes in the hit-map
        NHOLI=0
        NHOLO=0
        NHITI=0
        NHITO=0
* MU1
        IF(IQ(JBRHM+4).GT.0) NHITI=NHITI+1
        IF(IQ(JBRHM+4).LE.0) NHOLI=NHOLI+1
        DO I=1,3
          IF(IQ(JBRHM+I).GT.0) NHITO=NHITO+1
          IF(IQ(JBRHM+I).LE.0) NHOLO=NHOLO+1
        ENDDO
* MU2
        IF(IQ(JBRHM+8).GT.0) NHITI=NHITI+1
        IF(IQ(JBRHM+8).LE.0) NHOLI=NHOLI+1
        DO I=5,7
          IF(IQ(JBRHM+I).GT.0) NHITO=NHITO+1
          IF(IQ(JBRHM+I).LE.0) NHOLO=NHOLO+1
        ENDDO
* MU3
        IF(IQ(JBRHM+10).GT.0) NHITI=NHITI+1
        IF(IQ(JBRHM+10).LE.0) NHOLI=NHOLI+1
        IF(IQ(JBRHM+9).GT.0)  NHITO=NHITO+1
        IF(IQ(JBRHM+9).LE.0)  NHOLO=NHOLO+1
* MU4
        IF(IQ(JBRHM+12).GT.0) NHITI=NHITI+1
        IF(IQ(JBRHM+12).LE.0) NHOLI=NHOLI+1
        IF(IQ(JBRHM+11).GT.0) NHITO=NHITO+1
        IF(IQ(JBRHM+11).LE.0) NHOLO=NHOLO+1
* calculate the ratio of holes
        NHOL= 0
        NHIT= 0
        IF(NHITI.LT.3.AND.NHITO.LT.3) GOTO 99
        IF(NHITI.GE.3) THEN
          NHIT=NHITI
          NHOL=NHOLI
        ELSE
          IF(NHITO.GT.3) THEN
            NHIT=NHITO
            NHOL=NHOLO
          ELSE
            GOTO 99
          ENDIF
        ENDIF
        RHOL=REAL(NHOL)/REAL(NHIT)
* crezy cut on ratio of holes
        IF(RHOL.GT.0.4) GOTO 99      
*
* pixel,wire and pad indicators for MU3,MU4
        DO I=1,4
          DO J=1,3
            IND(I,J)=0
          ENDDO
        ENDDO
* estimation of the seed-branch coupling chi^2
        Q(JBR+45)=1.E+8
        CHIS=0.
        DIST=0.
        NHIS=0
* loops over collected hits
        DO 50 IH=1,IQ(JBR+8)
          JH=JBR+LCMUTR+IH
          IHT=IQ(JH)
          JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
          MUSL=IQ(JHT+3)
          IF(MUSL.LE.2) THEN
            JSDM=JSD+6*MUSL+51
            ERMS=Q(JSD+25+MUSL)
          ELSE
            JSDM=JSD+5*MUSL+54
            ERMS=Q(JSD+23+2*MUSL)
          ENDIF
          IHTR=IQ(JHT+5)
          IND(MUSL,IHTR)=IND(MUSL,IHTR)+1
* the case of wire
          IF(IHTR.EQ.1) THEN
            SINR=Q(JHT+7)
            COSR=SQRT(1.-SINR*SINR)
* seed extrapolation in the detector system 
            DSD=Q(JSDM+1)*COSR-Q(JSDM+2)*SINR
* error of multiple scattering
            SIG2=ERMS**2
* error of extrapolation
            SIG2=SIG2+((Q(JSDM+3)*COSR)**2+(Q(JSDM+4)*SINR)**2)
* measument error
            SIG2=SIG2+Q(JHT+11)**2
*
            DIST=DIST+(Q(JHT+8)-DSD)**2
            CHIS=CHIS+(Q(JHT+8)-DSD)**2/SIG2
            NHIS=NHIS+1
* the case of pad or pixel                    
          ELSE
* error of multiple scattering
            SIGX2=ERMS**2
            SIGY2=ERMS**2
* error of extrapolation
            SIGX2=SIGX2+Q(JSDM+3)**2
            SIGY2=SIGY2+Q(JSDM+4)**2
* measument error
            SIGX2=SIGX2+Q(JHT+11)**2
            SIGY2=SIGY2+Q(JHT+12)**2
*
            DIST=DIST+(Q(JHT+8)-Q(JSDM+1))**2
            DIST=DIST+(Q(JHT+9)-Q(JSDM+2))**2
            CHIS=CHIS+(Q(JHT+8)-Q(JSDM+1))**2/SIGX2
            CHIS=CHIS+(Q(JHT+9)-Q(JSDM+2))**2/SIGY2
            NHIS=NHIS+2
          ENDIF
  50    CONTINUE

*        print*,' '
*        DO I=1,4
*          print 1001,I,IBR,IND(I,1),IND(I,2),IND(I,3)
* 1001   FORMAT(2X,'MuSl ',I2,' Br ',I3,' hits(w,pd,px): ',3I3)
*        ENDDO

* kill the cases when the pads are not acompanied by wires
*        DO I=3,4
*          IF(IND(I,3).EQ.0) THEN
*            IF(IND(I,1)*IND(I,2).EQ.0) GOTO 99
*          ENDIF
*        ENDDO

* chi^2 of relation seed-branch
        Q(JBR+45)=CHIS/REAL(NHIS)

* kill the branch with chi**2/Nhit > CHISTM=100.
*        IF(Q(JBR+45).GT.CHISTM) GOTO 99
        IF(Q(JBR+45).GT.25.) GOTO 99

* estimator 1 = RHOL + chi**2/Nhit/10.
***        EST1=CHIKF+REAL(NHMD-IQ(JBR+8))
***        EST1=REAL(NHMD)/REAL(NHIS)+Q(JBR+45)
***        EST1=RHOL+0.1*Q(JBR+45)
        EST1=CHIKF
        Q(JBR+46)=EST1
        IQ(JBR+1) =1
*
        GOTO 100
  99    IQ(JBR+1)=-1
        Q(JBR+46)=0.
 100  CONTINUE
*
 200  CONTINUE
      RETURN
      END




