/* 

Wrapper for some OtrI functions to make them Fortran-callable

Author:    Dmitri Goloubkov

Created:   Feb 2001

 */

#include "arte/arte.hh"
#include "Otr/OtrI.h"

extern "C" {

  //Returns status of OtrHitPreparation:
  // 0 - use OtrI
  // 1 - use wax
  int otrhitpreparation_() {
    char* f=getenv("OtrHitPreparation");
    if (f) return atoi(f);
    else return 0;
  }
  
  // Returns channel index from GEDE information
  int otrifrommodule_(int &superlayer,
		      int &layer,
		      int &module,
		      int &sector,
		      int &monolayer,
		      int &wire	) {
    return OtrIFromModule(superlayer,
			  layer,
			  module,
			  sector,
			  monolayer,
			  wire);
  }
  
  // Returns channel index from GEDE information
  int otrifromnedelayerwire_(int &igede, int &monolayer, int &wire) {
    return OtrIFromNedeLayerWire(igede, monolayer, wire);
  }
  
  int otridfromindex_(int &ci) {return OtrIdFromIndex(ci);}
  int otriasdchannel_(int &ci) {return OtrIAsdChannel(ci);}
  int otriasdfromid_(int &chid) {return OtrIAsdFromId(chid);}
  
  int otriisdead_ (int &ci) {return OtrIIsDead (ci);}
  int otriisnoisy_(int &ci) {return OtrIIsNoisy(ci);}
  int otriisok_   (int &ci) {return OtrIIsOk   (ci);}
  int otriisbad_  (int &ci) {return OtrIIsBad  (ci);}
}
