*CMZ :  4.05/03 01/06/96  15.30.23  by  Rainer Mankel
*-- Author :    Rainer Mankel   01/06/96

      subroutine pk1mc(imc,islsta,islend,chopt)

*     **** pick mc track
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"
#include "pris/zgraf.fi"
      integer islsta, islend, iso, ipl, imc
      integer nso, nsomax
      parameter (nsomax=200)
      integer isl, imim, npoint, v, seg, segmin, segmax, point, p1, p2,
     +     iclose, gcode
      real xxx(nsomax), yyy(nsomax), wh(3), rclose, r, rseg
      logical charged
      character*(*) chopt
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

*     **** check id
      gcode = itopp_gean(omtra_topp(imc))

      if (
     +     (gcode.eq.8)  .or. (gcode.eq.9)
     +     .or. (gcode.eq.11) .or. (gcode.eq.12)
     +     .or. (gcode.eq.14) .or. (gcode.eq.15)
     +     .or. (gcode.eq.2)  .or. (gcode.eq.3)
     +     .or. (gcode.eq.5)  .or. (gcode.eq.6)
     +     ) then
         charged = .true.

      elseif (gcode.eq.1) then
         charged = .false.      ! gamma

      elseif (gcode.eq.10.or.gcode.eq.16) then
         charged = .false.      ! K0L, K0S

      elseif (gcode.eq.13 .or. gcode.eq.25) then
         charged = .false.      ! n, n~

      elseif (gcode.eq.53.or.gcode.eq.54 ! b0, b0=
     +        .or.gcode.eq.37.or.gcode.eq.38 ! d0, d0=
     +        .or.gcode.eq.49) then ! J/Psi
         charged = .false.
      else
         go to 999
      endif

      if ((.not.charged) .and. (.not.lneutzg)) go to 999

      npoint = 0

*     **** find vertex
      if (omtra_bver(imc).gt.0.and.omtra_bver(imc).le.iq(jmver+2)) then
         v = omtra_bver(imc)
         npoint = npoint + 1

*        **** 3D point
         wh(1) = fmver_x(v)
         wh(2) = fmver_y(v)
         wh(3) = fmver_z(v)

*        **** projection
         call dipro(wh,xxx(npoint),yyy(npoint))

      else
         print *,' () dimc: no vertex for mc=', imc
      endif

*     **** loop over mimps in sorted order
      nso = nmimmh(imc)
      do 30 iso=1,nso
         imim = imimmh( istamh(imc) + iso )
         if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
            print *,' () dimc: invalid imim=',imim,' iq(jmimp+2)=',
     +           iq(jmimp+2)
            stop 'dimc'
         endif

*        **** check SL
         ipl = imimp_gede(imim)
*        **** avoid packed ipl's in ECAL
         if (ipl.gt.iq(jgede+2)) go to 30
         isl = ogede_gesl(ipl)
         if (isl.lt.islsta.or.isl.gt.islend) go to 30
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 30
            if (.not.lscopzg(isl)) go to 30
         endif
*        **** no merged points
         if (omimp_mtra(imim).eq.0) go to 30

         if (npoint.ge.nsomax) then
            print *,' () pkmc: overflowing npoint=', npoint,
     +           ' imc=', imc,' nso=', nso
            go to 999
         endif
         npoint = npoint + 1

*        **** 3D point
         wh(1) = fmimp_x(imim)
         wh(2) = fmimp_y(imim)
         wh(3) = fmimp_z(imim)

*        **** projection
         call dipro(wh,xxx(npoint),yyy(npoint))

 30   continue

      if (.true.) then          ! look for end vertex
         if (pmtra_ever(imc).gt.0) then
            v = mmtra_ever(pmtra_ever(imc))
            if (npoint.ge.nsomax) then
               print *,' () pkmc: overflowing npoint=', npoint,
     +              ' imc=', imc,' nso=', nso
               go to 999
            endif
            npoint = npoint + 1

*           **** 3D point
            wh(1) = fmver_x(v)
            wh(2) = fmver_y(v)
            wh(3) = fmver_z(v)

*           **** projection
            call dipro(wh,xxx(npoint),yyy(npoint))
         endif
      endif

      if (npoint.le.1) go to 999

*     **** find closest mimp
      rclose = 1.e10
      iclose = 0
      do point=1,npoint
         r = (xxx(point)-xpickzg)**2 + (yyy(point)-ypickzg)**2
         if (point.eq.1.or.r.lt.rclose) then
            iclose = point
            rclose = r
         endif
      enddo

*     **** check adjoining segments
      if (iclose.ne.1) then     ! fix endpoints
         segmin = 1
      else
         segmin = 2
      endif
      if (iclose.ne.npoint) then
         segmax = 2
      else
         segmax = 1
      endif
      do seg=segmin,segmax
         p1 = iclose + seg - 2
         p2 = p1 + 1
         rseg = sqrt( (xpickzg-xxx(p1))**2 + (ypickzg-yyy(p1))**2)
     +        + sqrt( (xpickzg-xxx(p2))**2 + (ypickzg-yyy(p2))**2)
     +        - sqrt( (xxx(p1)-xxx(p2))**2 + (yyy(p1)-yyy(p2))**2)
         if (rseg.lt.rpickzg) then
            idpickzg = imc
            rpickzg = rseg
         endif
      enddo

 999  end
