// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerHitStrip
// node class for 1D strip measurements

#ifndef rangerHitStrip_HH
#define rangerHitStrip_HH

#include "CLHEP/Matrix/Matrix.h"
#include "CLHEP/Matrix/Vector.h"
#include "rang/Hit.hh"
#include "rang/FitMode.hh"

class rangerHitStrip : public rangerHit {

public:

  rangerHitStrip();
  rangerHitStrip(ArtePointer<RHIT> rhit,rangerFitMode fm);
  rangerHitStrip(ArtePointer<HITB>   hb,rangerFitMode fm);
  ~rangerHitStrip();

  void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);
//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStateP* s);
//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStatePI* s);
  inline int dim() const {return 1;};         // dimension of measurement

private:

};

#endif
