// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgdlwbord_
// Fortran shortcut interface to getter functions which returns borders of 
// the domain window associated with a domain layer.

// Input parameter: pointer to domain layer.
// Output parameters: xmin...ymax

// See also rgwibord.C

#include "rang/DomLay.hh"
#include "rang/DomWin.hh"

extern "C" {
  void rgdlwbord_(rangerDomLay*& dl,  // domain layer (input)
		  float& xmin,        // lower x border of assoc. dom. window
		  float& xmax,        // upper x 
		  float& ymin,        // lower y
		  float& ymax) {      // upper y
    if (dl) {
      xmin = dl->win()->xmin();
      xmax = dl->win()->xmax();
      ymin = dl->win()->ymin();
      ymax = dl->win()->ymax();
//       cout << "rgdlwbord: xmin=" << xmin << " xmax=" << xmax << endl;
    }
    else {
      cout << "rgdlwbord: invalid dl=" << dl << endl;
    }
  }
}



    



