
// 
//  Author:  A. Spiridonov                     Created:  15-Apr-2000  
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 

// rgtabssws_
// For a given seed tableau, locate an array of the seed set belonging to 
// a specific window. If search successful nseedw > 0 , otherwise nseedw = 0
// Tailored from rgtabssw.C

#include "rang/rgtabss.hh"
#include "rang/SeedTableau.hh"
#include "rang/SeedSet.hh"
#include "rang/DomWin.hh"

extern "C" void rgtabssws_(rangerDomWin*& dw,rangerSeedTableau*& st,
			   const int& method,rangerSeedSet** svecw,int& nseedw)  
{
  rangerSeedSet* svec[100];
  int nseed = 0;
  nseedw = 0;
  
  //     cout << "rgtabssw: call rgtabss" << endl;
  rgtabss_(st,method,100,svec,nseed);
  //     cout << "rgtabssw: rgtabss returns nseed=" << nseed << endl;
  
  if(nseed > 0) 
    {
      for (int i=0; i<nseed; ++i) 
	{
	  //       cout << "check seed " << svec[i] << endl;
	  //       cout << "          window " << svec[i]->win() << endl;
	  if (svec[i]->win() == dw) 
	    {
	      // 	cout << "seed found" << endl;
	      //	      cout << "seed found cmp " << dw->cmp() << endl;
	      svecw[nseedw] = svec[i];
	      ++nseedw;
	    }
	}
    }
  else
    {
      cout << " rgtabssws: seed set not found " << endl;
    }
}
