// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgxprosqpt
// Fortran setter function for both the ft link number and the qpt estimate 
// of a given horizontal projection track candidate.

// The ft link is the identifier of the track candidate in the intrinsic
// pattern recognition common block /zft/ (see include/zf.fi)

#include "rang/Domain.hh"
#include "rang/DomWin.hh"
#include "rang/DomObj.hh"
#include "rang/XPro.hh"
#include "rang/XWin.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgxprosqpt_(const int& ft,const double& qpt) {
    rangerDO->xpro()->qptSet(ft,qpt);
  }
}
