*-- Author :    Rainer Mankel   29/09/95

      subroutine tfdhlcr(izf,dl,nhlmx,hl,nhl)

*     **** give list of available hits in domain layer dl
      implicit none

      integer izf,pl,nhl,nhlmx,hl(*),ii,ih,tumchit,pl_last,dl,dh,dom
      integer message_id_1
      real u,du,u_hit,x_pred,y_pred,tfxseg

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zfpar.fi"
#include "rang/zcut.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

      data message_id_1 /1/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      nhl = 0
      pl_last = 0

      if (diag_level.ge.5) print *,' tfdhlcr: get hitlist for dl=', dl,
     +     'xmin/max=',xmin_dw(win_dl(dl)),xmax_dw(win_dl(dl))

*     **** loop over hits in domain layer
      do 10 ii=1,999
         if (ii.eq.1) then
            dh = hit1_dp(dl)
         else
            dh = nxthit_dh(dh)
         endif
         if (diag_level.ge.5) then
            print *,' tfdhlcr: dh=', dh
            if (dh.ne.0) print *,'         mc=', tumchit(hitb_dh(dh))
         endif
         if (dh.eq.0) go to 11
         ih = hitb_dh(dh)
         pl = ihitb_gede(ih)

         if (diag_level.ge.5) print *,' tfdhlcr: ih,pl=', ih,pl
         if (pl.lt.1.or.pl.gt.iq(jgede+2)) then
            print *,' () tfdhlcr: invalid plane pl=',pl
            go to 11
         endif

         if (pl.ne.pl_last) then ! update prediction window pointer
            if (l_svd.or.l_mag) then
*              **** 3D tracking
               x_pred = xx_zf(1,izf)
     +              + xx_zf(3,izf) * (fgede_zmin(pl) - z_zf(izf))
               y_pred = xx_zf(2,izf)
     +              + xx_zf(4,izf) * (fgede_zmin(pl) - z_zf(izf))

               if (abs(fgede_rot(2,pl)).gt.0.001) then
                  u = x_pred * fgede_rot(1,pl)
     +                 - y_pred * fgede_rot(2,pl)
               else
                  u = x_pred * fgede_cos(pl)   - y_pred * fgede_sin(pl)
               endif
               if (l_mag) then
                  du = 10.
               else
                  du =  3.
               endif
            elseif (l_2dx) then
               x_pred = xx_zf(1,izf)
     +              + xx_zf(3,izf) * (fgede_zmin(pl) - z_zf(izf))
               u = x_pred
               du = 3.
            elseif (l_2dy) then
               dom = laydom_dl(dl)
               x_pred = tfxseg(fgede_zmin(pl),dom)
**               x_pred = tfxint(fgede_zmin(pl))
               if (x_pred.gt.-1000..and.x_pred.lt.1000.) then
               else
                  print *,' () tfdhlcr: invalid x_pred=',x_pred,
     +                 ' for pl,zmin=',pl,fgede_zmin(pl)
                  go to 10
               endif
               y_pred = xx_zf(2,izf)
     +              + xx_zf(4,izf) * (fgede_zmin(pl) - z_zf(izf))
               if (igede_cmp(pl).eq.1.or.igede_cmp(pl).eq.3) then
                  u = x_pred * fgede_rot(1,pl)
     +                 - y_pred * fgede_rot(2,pl)
                  du = 3.
               elseif (igede_cmp(pl).eq.2) then
                  u = x_pred * fgede_cos(pl) - y_pred * fgede_sin(pl)
                  du = 3.
               else
                  print *,' tfdhlcr: unsupported cmp=', igede_cmp(pl)
                  go to 11
               endif
            else
               print *,' tfdhlcr: unsupported tracking mode'
               print *,' l_svd,l_mag,l_2dx,l_2dy=',
     +              l_svd,l_mag,l_2dx,l_2dy
               go to 11
            endif
            pl_last = pl
            if (diag_level.ge.5) then
               print *,' tfdhlcr: pl, cmp=', pl, igede_cmp(pl)
               print *,' tfdhlcr: number of hits in plane=',
     +              igede_hit1(pl)-igede_hitl(pl)
            endif
         endif

*        **** check hit

*        **** check if hit really belongs to plane
         if (ihitb_gede(ih).ne.pl) then
            print *,' () tfdhlcr: ih, ihitb_gede, pl=',
     +           ih, ihitb_gede(ih), pl
         endif
*        **** check if hit already used
         if (lremzc) then
            if (segstor_zfpar) then
               if (phitb_rseg(ih).gt.0) go to 10
            else
               if (phitb_rtra(ih).gt.0) go to 10
            endif
         endif

         u_hit = fhitb_x(ih)
         if (diag_level.ge.5) then
            print *,' x_pred, y_pred,u,du,u_hit=',
     +           x_pred, y_pred,u,du,u_hit
         endif

         if (abs(u_hit - u).gt.du) then
            if (diag_level.ge.5) then
               print *,' tfdhlcr: hit outside window,',
     +              ' u_hit, u, du=',
     +              u_hit, u, du
            endif
            go to 10
         endif

*        **** put into array
         if (nhl.lt.nhlmx) then
            nhl = nhl + 1
            hl(nhl) = ih
         else
            call mepric(message_id_1,1,
     +           'tfdhlcr: overflowing nhl, some hits skipped')
            go to 11
         endif

 10   continue
      print *,' () tfdhlcr: more than 999 hits in dl=',dl
 11   continue

      end






