*-- Author :    Rainer Mankel   19/05/95
*-- changed:    A.Spiridonov    24/04/98

      subroutine tfstat1()

*     **** pattern recognition efficiencies etc ( pattern tracker ) 

      implicit none 

#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"

#include "pris/zpstat.fi"
#include "rang/FLAGHist.hh"
#include "rang/zfout.fi"

      integer ncounter, code_eplus, code_eminus, code_muplus,
     +        code_muminus, tpname
      parameter (ncounter=9)
                 ! counter=1  for e+-
                 !         2  for mu+-
                 !         3  for l+-
                 !         4  for pi+-
                 !         5  for J/Psi
                 !         6  for K0S
                 !         7  for B0
                 !         8  for charged tracks
                 !         9  for ghosts

      integer counter_mc_evt(ncounter), ! reference mc objects per evt
     +        counter_mc_all(ncounter), !           ||        (all evts)
     +        counter_rc_evt(ncounter), ! reference rc objects per evts
     +        counter_rc_all(ncounter), !           ||        (all evts)
     +        counter_ef_all(ncounter), ! defined efficiency evts
     +        counter_ge_evt(ncounter), ! generated mc objects per evt
     +        counter_ge_all(ncounter)  !           ||        (all evts)
      
      real    counter_evtef (ncounter), ! current evt efficiencies
     +        counter_allef (ncounter), ! current run efficiencies
     +        accumul_ef_all(ncounter)  ! summed efficiency   (all evts)
      integer counter_bgen_evt  ! golden Bs
      integer counter_bgen_all
      integer counter, ii, mc, jaux, rc, nrc, ialia, it, gold, jgold,
     +        mcgold, counter_lep, lepton, n_events
      character*20 cname
      real mass, charge, pmc, fracmc
      character*20 counter_name(ncounter) ! name of counter
      logical lrefpat(7,maxgold), lrc(7,maxgold)

      data n_events /0/

      data counter_name / 'golden e+-', 'golden mu+-', 'golden l+-',
     +      'golden pi+-', 'golden J/Psi', 'golden K0S', 'golden B0',
     +      'charged tracks', 'ghosts' /

      data counter_mc_evt /ncounter*0/,
     +     counter_mc_all /ncounter*0/,
     +     counter_rc_evt /ncounter*0/,
     +     counter_rc_all /ncounter*0/,
     +     counter_ef_all /ncounter*0/,
     +     accumul_ef_all /ncounter*0./,
     +     counter_ge_evt /ncounter*0./,
     +     counter_ge_all /ncounter*0./,
     +     counter_bgen_all  /0/

      save n_events, counter_mc_evt, counter_mc_all, counter_rc_evt,
     +  counter_rc_all, counter_ef_all, accumul_ef_all, counter_name,
     +     counter_bgen_evt, counter_bgen_all, counter_ge_evt,
     +     counter_ge_all

      integer if_hist ! 2 pr&hist, 1 hist, 0 
      data if_hist/1/
      save if_hist
      character*3 name_r(4)            ! name of golden part
      data name_r/'mu+','mu-','pi+','pi-'/
      integer muon1,muon2,pion1,pion2  ! mc golden mu+,mu-,pi+,pi-
      integer n_r(7),rc_r(7)           ! num of rec ref golden
      integer jj
      real p_r(5,7),p_mc(5,7),d_p(5,7),d_norm(5,7),ch2_r(7),frac_r(7) 
      real p_r1(5),p_mc1(5),d_p1(5),d_norm1(5),ch2_r1
      integer n_e,n_a

*      parameter (n_e=6)
      parameter (n_e=8)
      parameter (n_a=7)

      integer ne_rc(n_e,7),ne_re(n_e,7),mc_r(7)
      integer na_rc(n_a,7),na_re(n_a,7)
      real eff_e(n_e,7),eff_a(n_a,7)
      real err_e(n_e,7),err_a(n_a,7)
      real bin_e(n_e),bin_a(n_a)

*      data bin_e/10., 20., 40., 80., 120., 300./
*      data bin_a/.01, .03, .05, .1, .15, .2, .3/
      data bin_e/5., 10., 15., 25., 35., 50., 80., 300./
      data bin_a/.01, .03, .05, .07, .1, .15, .3/

      integer ind_e,ind_a,istat,if_store,id
      real e_mc,a_mc
      logical if_rec(7)

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )

      integer imc,ibatch
      data ibatch/0/

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"

      call rginit()

      if (n_events.eq.0) then
         code_eplus  = tpname('e+')
         code_eminus = tpname('e-')
         code_muplus = tpname('mu+')
         code_muminus = tpname('mu-')
         if (min0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .le.0.or.
     +        max0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .gt.ntopp()) then
            print *,' () tfstat: invalid topp pointer ',
     +           code_eplus,code_eminus,code_muplus,code_muminus
            go to 999
         endif

         do ii=1,n_e
           do jj=1,7
             ne_rc(ii,jj) = 0
             ne_re(ii,jj) = 0
           end do
         end do
         do ii=1,n_a
           do jj=1,7
             na_rc(ii,jj) = 0
             na_re(ii,jj) = 0
           end do
         end do

      endif                         ! end of initialisation

      n_events = n_events + 1

      do counter=1,ncounter         ! reset event scope counters
       counter_mc_evt(counter) = 0
       counter_rc_evt(counter) = 0
       counter_ge_evt(counter) = 0
      enddo
      counter_bgen_evt = 0

      do jj=1,7
        if_rec(jj)= .false.
      end do

      do jgold=1,7
        n_r(jgold) = 0
      end do

      if (ibatch.eq.0.and.lref_zfout.and.if_hist.eq.2) then
       print *,' '
       print *,' R e f e r e n c e     T r a c k s :'
       print *,' '
       print '(3a5,a6,a20)',  ! headline
     +        'mc','rc','nrc','pmc','name'
      endif

      do ii=1,pstat_nrefpat  ! loop over reference tracks

       mc = pstat_refpat(ii)

       jgold = 0
       if(mc.eq.muon1) jgold=1
       if(mc.eq.muon2) jgold=2
       if(mc.eq.pion1) jgold=3
       if(mc.eq.pion2) jgold=4
       if(jgold.gt.0) then
         e_mc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
         a_mc = sqrt( fmtra_px(mc)**2/fmtra_pz(mc)**2
     +        +       fmtra_py(mc)**2/fmtra_pz(mc)**2 )
         do jj=1,n_e
           if(e_mc.le.bin_e( n_e - jj + 1)) ind_e = n_e - jj + 1
         end do
         do jj=1,n_a
           if(a_mc.le.bin_a( n_a - jj + 1)) ind_a = n_a - jj + 1
         end do
*         print *,'e,a ie,ia',e_mc,a_mc,ind_e,ind_a
         ne_re(ind_e,jgold) = ne_re(ind_e,jgold) + 1
         na_re(ind_a,jgold) = na_re(ind_a,jgold) + 1
        end if

*      **** check if reconstructed
       if (pmtra_rtra(mc ).gt.0) then
        jaux = pmtra_rtra(mc)
        rc = mmtra_rtra(jaux)
        nrc = 1

            imc = mc
            if(jgold.gt.0) then    
            n_r(jgold) = n_r(jgold) + 1
            call tftparm1(rc,imc,p_r1,p_mc1,d_p1,d_norm1,ch2_r1,istat)
            if(n_r(jgold).eq.1) then
              ne_rc(ind_e,jgold) = ne_rc(ind_e,jgold) + 1
              na_rc(ind_a,jgold) = na_rc(ind_a,jgold) + 1
            end if

            if_store = 0
            if(n_r(jgold).eq.1.or.ch2_r1.lt.ch2_r(jgold)) if_store=1 

            if(if_store.ne.0) then
              do jj=1,5                        ! store residuals
                rc_r  (   jgold) = rc
                p_r   (jj,jgold) = p_r1(jj)
                p_mc  (jj,jgold) = p_mc1(jj)
                d_p   (jj,jgold) = d_p1(jj)
                d_norm(jj,jgold) = d_norm1(jj)
                ch2_r (   jgold) = ch2_r1
                frac_r(   jgold) = fracmc
                mc_r  (   jgold) = mc
                if_rec(   jgold) = .true.
              end do
            end if
            end if

*       **** count
        do 10 ialia=1,20
         jaux = xmtra_rtra(jaux)
         if (jaux.gt.0) then
          nrc = nrc + 1

            imc = mc
            if(jgold.eq.0) go to 10   
            n_r(jgold) = n_r(jgold) + 1
            call tftparm1(rc,imc,p_r1,p_mc1,d_p1,d_norm1,ch2_r1,istat)
            if(n_r(jgold).eq.1) then
              ne_rc(ind_e,jgold) = ne_rc(ind_e,jgold) + 1
              na_rc(ind_a,jgold) = na_rc(ind_a,jgold) + 1
            end if

            if_store = 0
            if(n_r(jgold).eq.1.or.ch2_r1.lt.ch2_r(jgold)) if_store=1 

            if(if_store.ne.0) then
              do jj=1,5                        ! store residuals
                rc_r  (   jgold) = rc
                p_r   (jj,jgold) = p_r1(jj)
                p_mc  (jj,jgold) = p_mc1(jj)
                d_p   (jj,jgold) = d_p1(jj)
                d_norm(jj,jgold) = d_norm1(jj)
                ch2_r (   jgold) = ch2_r1
                frac_r(   jgold) = fracmc
                mc_r  (   jgold) = mc
                if_rec(   jgold) = .true.
              end do
            end if

         else
          go to 11
         endif
 10     continue
 11     continue
       else
        rc = 0
        nrc = 0
       endif

       if (.true..and.if_hist.eq.2) then
         if (mc.eq.muon1.or.mc.eq.muon2.or.
     +       mc.eq.pion1.or.mc.eq.pion2) then
          call tupaty(omtra_topp(mc),cname,charge,mass,'G')
          pmc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
          if (leff_zfout) then
             print '(3i5,f6.2,1x,a19)',
     +            mc,rc,nrc,pmc,cname
          endif
         endif
       end if

*       if (ibatch.eq.0.and.lref_zfout.and.if_hist.eq.2) then
*        call tupaty(omtra_topp(mc),cname,charge,mass,'G')
*        pmc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
*        print '(3i5,f6.2,1x,a19)',
*     +        mc,rc,nrc,pmc,cname
*       endif


       counter = 8  ! charged particles
       counter_mc_evt(counter) = counter_mc_evt(counter) + 1
       if (nrc.gt.0) then
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif
      enddo                                              ! reference tracks

      counter = 9  ! ghosts
      do it=1,iq(jrtra+2)  ! loop over reconstructed tracks
       if (prtra_mtra(it).eq.0) then  ! check if no corresponding MC
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif
      enddo  ! RC tracks
      counter_mc_evt(counter) = counter_mc_evt(8)  ! normalize to ref tr

*     **** loop over golden Bs
      do gold=1,pstat_ngold
       counter_bgen_evt = counter_bgen_evt + 1 ! count Bs
       do jgold=1,4  ! loop over stable golden particles
        mcgold = pstat_gold(jgold,gold)
        lrefpat(jgold,gold) = .false.  ! initialize ref track flag
        lrc    (jgold,gold) = .false.  ! initialize reco flag
        do 20 mc=1,pstat_nrefpat  ! gold part occurs in ref tracks ?
         if (pstat_refpat(mc).eq.mcgold) then
          lrefpat(jgold,gold) = .true.
          go to 21
         endif
 20     continue ! mc ref loop
 21     continue
*       **** check if reconstructed
        lrc(jgold,gold) = pmtra_rtra(mcgold).gt.0
       enddo
       lrefpat(5,gold) = lrefpat(1,gold).and.lrefpat(2,gold) ! J/Psi
       lrefpat(6,gold) = lrefpat(3,gold).and.lrefpat(4,gold) ! K0S
       lrefpat(7,gold) = lrefpat(5,gold).and.lrefpat(6,gold) ! B0
       lrc(5,gold) = lrc(1,gold).and.lrc(2,gold) ! J/Psi
       lrc(6,gold) = lrc(3,gold).and.lrc(4,gold) ! K0S
       lrc(7,gold) = lrc(5,gold).and.lrc(6,gold) ! J/Psi
      enddo


      counter = 3 ! l+-
      do gold=1,pstat_ngold
       do jgold=1,2
        counter = 3 ! l+-
        lepton = omtra_topp(pstat_gold(jgold,gold))
        if (lepton.eq.code_eplus.or.lepton.eq.code_eminus) then
         counter_lep = 1
        elseif (lepton.eq.code_muplus.or.lepton.eq.code_muminus) then
         counter_lep = 2
        else
         print *,' () tfstat: invalid lepton: ', lepton
         counter_lep = 2
        endif
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        counter_ge_evt(counter_lep) = counter_ge_evt(counter_lep) + 1
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         counter_mc_evt(counter_lep) = counter_mc_evt(counter_lep) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
          counter_rc_evt(counter_lep) = counter_rc_evt(counter_lep) + 1
         endif
        endif
       enddo
      enddo

      counter = 4 ! pi+-
      do gold=1,pstat_ngold
       do jgold=3,4
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=5,7
       do gold=1,pstat_ngold
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        jgold=counter
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=1,ncounter
*      **** event-based efficiencies
       if (counter_mc_evt(counter).gt.0) then
        counter_ef_all(counter) = counter_ef_all(counter) + 1
        counter_evtef(counter) = float(counter_rc_evt(counter))
     +                         / float(counter_mc_evt(counter))
        accumul_ef_all(counter) = accumul_ef_all(counter)
     +                                 + counter_evtef(counter)
       else
        counter_evtef(counter) = 0.
       endif
*      **** update all counters
       counter_mc_all(counter) = counter_mc_all(counter)
     +                         + counter_mc_evt(counter)
       counter_rc_all(counter) = counter_rc_all(counter)
     +                         + counter_rc_evt(counter)
       counter_ge_all(counter) = counter_ge_all(counter)
     +                         + counter_ge_evt(counter)

       if (counter_mc_all(counter).gt.0) then
        counter_allef(counter) = float(counter_rc_all(counter))
     +                         / float(counter_mc_all(counter))
       else
        counter_allef(counter) = 0.
       endif
      enddo ! updating of counters
      counter_bgen_all = counter_bgen_all + counter_bgen_evt

*     **** fill histograms

#ifdef rangerHIST
      if(if_hist.gt.0) then
        do jj=1,7
          if(if_rec(jj)) then
            if(jj.eq.1.or.jj.eq.2) id = 200
            if(jj.eq.3.or.jj.eq.4) id = 300
            do ii=1,5
              call hf1(id+10+ii,d_norm(ii,jj),1.)
            end do

*            call hf1(id+16,(abs(p_r(5,jj))-p_mc(5,jj))/p_mc(5,jj),1.)

            if(frac_r(jj).lt.0.9999) then
              call hf1(id+17,(1.-frac_r(jj))*100.,1.) 
            end if

            mc=mc_r(jj)
            e_mc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2
     +                 +fmtra_pz(mc)**2)
            a_mc = sqrt( fmtra_px(mc)**2/fmtra_pz(mc)**2
     +        +       fmtra_py(mc)**2/fmtra_pz(mc)**2 )*1000.

            call hf1(id+18,e_mc,1.)
            call hf1(id+19,a_mc,1.)
            call hf1(id+20,float(n_r(jj)),1.)

          end if
        end do
      end if    ! end of fill histograms
#endif

*     **** print reconstructed tracks
      if (ibatch.eq.0.and.lrec_zfout.and.if_hist.eq.2) then
       print *,' '
       print *,' R e c o n s t r u c t e d     T r a c k s :'
       print *,' '
       print '(a4,a5,a6,2a5,a8)',  ! headline
     +       ' trk','mc','frac','hou','fit','chi'

       do it=1,iq(jrtra+2)
        call tfremcn(it,mc,fracmc)
        if(mc.eq.muon1.or.mc.eq.muon2.or.
     +     mc.eq.pion1.or.mc.eq.pion2    ) then  
           print '(i4,i5,f6.2,2i5,f8.2)',
     +     it,mc,fracmc,irtra_hou(it),irtra_fit(it),frtra_chi(it)
        end if
       end do

*       do it=1,iq(jrtra+2)
*        call tfremcn(it,mc,fracmc)
*        print '(i4,i5,f6.2,2i5,f8.2)',
*     +   it,mc,fracmc,irtra_hou(it),irtra_fit(it),frtra_chi(it)
*       enddo

       print *,' '
       print *,' T r a c k s       R e s i d u a l s:'
       print *,' '
       
       do jgold=1,4
         if(n_r(jgold).gt.0) then
           print '(2x,a3,"   n_r= ",i2," rc= ",i4," chi2= ",f8.3
     +             ," frac= ",f8.3)'
     +           ,name_r(jgold),n_r(jgold),rc_r(jgold),ch2_r(jgold)
     +           ,frac_r(jgold)
           print '(" p_r    ",6(x,f9.4))',(p_r   (ii,jgold),ii=1,5)
     +           ,(1./p_r(5,jgold))
           print '(" p_mc   ",6(x,f9.4))',(p_mc  (ii,jgold),ii=1,5)
     +           ,(1./p_mc(5,jgold))
           print '(" d_p    ",5(x,f9.4))',(d_p   (ii,jgold),ii=1,5)
           print '(" d_norm ",5(x,f9.4))',(d_norm(ii,jgold),ii=1,5)
         end if
       end do

      endif                               ! end of print reconstructed tracks

*     **** printout

      if (leff_zfout) then

        do ii=1,n_e
            eff_e(ii,1) = float(ne_rc(ii,1)+ne_rc(ii,2)) 
     +         /(1.e-10 + float(ne_re(ii,1)+ne_re(ii,2))) * 100. 
            err_e(ii,1) = 
     +      sqrt(float(ne_re(ii,1)+ne_re(ii,2)-ne_rc(ii,1)-ne_rc(ii,2))
     +      * eff_e(ii,1))/float(ne_re(ii,1)+ne_re(ii,2))*10.

        end do
        do ii=1,n_a
            eff_a(ii,1) = float(na_rc(ii,1)+na_rc(ii,2)) 
     +         /(1.e-10 + float(na_re(ii,1)+na_re(ii,2))) * 100.
            err_a(ii,1) = 
     +      sqrt(float(na_re(ii,1)+na_re(ii,2)-na_rc(ii,1)-na_rc(ii,2))
     +      * eff_a(ii,1))/float(na_re(ii,1)+na_re(ii,2))*10.
        end do

        do ii=1,n_e
            eff_e(ii,3) = float(ne_rc(ii,3)+ne_rc(ii,4)) 
     +         /(1.e-10 + float(ne_re(ii,3)+ne_re(ii,4))) * 100. 
            err_e(ii,3) = 
     +      sqrt(float(ne_re(ii,3)+ne_re(ii,4)-ne_rc(ii,3)-ne_rc(ii,4))
     +      * eff_e(ii,3))/float(ne_re(ii,3)+ne_re(ii,4))*10.
        end do
        do ii=1,n_a
            eff_a(ii,3) = float(na_rc(ii,3)+na_rc(ii,4)) 
     +         /(1.e-10 + float(na_re(ii,3)+na_re(ii,4))) * 100.
            err_a(ii,3) = 
     +      sqrt(float(na_re(ii,3)+na_re(ii,4)-na_rc(ii,3)-na_rc(ii,4))
     +      * eff_a(ii,3))/float(na_re(ii,3)+na_re(ii,4))*10.
        end do

       print '(/)'   
       print '(" p , Gev/c   ",10f6.1)',(bin_e(ii), ii=1,n_e)

       print '(" mu rc vs p  ",10i6)'
     +        ,( (ne_rc(ii,1)+ne_rc(ii,2)), ii=1,n_e )
       print '(" mu re vs p  ",10i6)'
     +        ,( (ne_re(ii,1)+ne_re(ii,2)), ii=1,n_e )
       print '(" mu eff vs p ",10f6.1)'
     +        ,( eff_e(ii,1), ii=1,n_e )
       print '("    error    ",10f6.1)'
     +        ,( err_e(ii,1), ii=1,n_e )

       print '(" pi rc vs p  ",10i6)'
     +        ,( (ne_rc(ii,3)+ne_rc(ii,4)), ii=1,n_e )
       print '(" pi re vs p  ",10i6)'
     +        ,( (ne_re(ii,3)+ne_re(ii,4)), ii=1,n_e )
       print '(" pi eff vs p ",10f6.1)'
     +        ,( eff_e(ii,3), ii=1,n_e )
       print '("    error    ",10f6.1)'
     +        ,( err_e(ii,3), ii=1,n_e )

       print '(/)'   
       print '(" angle , mlrd",10f6.1)',((bin_a(ii)*1000.), ii=1,n_a)
       print '(" mu rc vs a  ",10i6)'
     +        ,( (na_rc(ii,1)+na_rc(ii,2)), ii=1,n_a )
       print '(" mu re vs a  ",10i6)'
     +        ,( (na_re(ii,1)+na_re(ii,2)), ii=1,n_a )
       print '(" mu eff vs a ",10f6.1)'
     +        ,( eff_a(ii,1), ii=1,n_e )
       print '("    error    ",10f6.1)'
     +        ,( err_a(ii,1), ii=1,n_e )

       print '(" pi rc vs a  ",10i6)'
     +        ,( (na_rc(ii,3)+na_rc(ii,4)), ii=1,n_a )
       print '(" pi re vs a  ",10i6)'
     +        ,( (na_re(ii,3)+na_re(ii,4)), ii=1,n_a )
       print '(" pi eff vs a ",10f6.1)'
     +        ,( eff_a(ii,3), ii=1,n_e )
       print '("    error    ",10f6.1)'
     +        ,( err_a(ii,3), ii=1,n_e )

       print *,' '
       print *,' G o l d e n     T r a c k s :'
       print *,' '

       do gold=1,pstat_ngold
        print '(''---'',4(i5,1x,a4,1x,l1,''---''))',
     +         (pstat_gold(jgold,gold),
     +         htopp_name(1,omtra_topp(pstat_gold(jgold,gold))),
     +         lrefpat(jgold,gold),jgold=1,4)
       enddo

       print 101, n_events,
     +            (counter_name(counter),counter_mc_evt(counter),
     +            counter_rc_evt(counter),100.*counter_evtef(counter),
     +            counter_mc_all(counter),
     +            counter_rc_all(counter),100.*counter_allef(counter),
     +            counter_ge_all(counter),
     +                               counter=1,ncounter)

 101   format(//
     + ' |=====================',
     + '====================================================| '/
     + ' |       statis',
     + 'tics from tfstat      nevents=',i6,'                        |'/
     + ' |=====================',
     + '====================================================|'/
     + ' | Counter     ',
     + '    MC(evt) RC(evt) ef(evt)  MC(run) RC(run) ef(run)',
     +      '    gen ','|'/
     + 9(' | ',a15,2i7,f7.2,5x,2i7,f7.2,i9,' |'/),
     + ' |=====================',
     + '====================================================| ')
      endif

 999  end



