// ********************************************************************
//
//  Author:       Wouter Hulsbergen (July 2001)
//
//  Description: Set of routines to access hit patterns for vds and
//  main tracker. For more information, see source file.
//
//  Recent modifications:
//
// ********************************************************************

#ifndef __RCHITPATTERN_HH__
#define __RCHITPATTERN_HH__

#include <arte/arte.hh>

namespace rcHitPattern
{
   // Returns the number of nonzero bits in int.
  unsigned int nnonzero(unsigned int bitpattern) ;
  
  // Returns the number of vds planes traversd by rtra.
  unsigned int nplanevds(ArtePointer<RTRA> rtra) ;

  // Returns the number of traversed vds planes with reconstructed hit.
  unsigned int nhitplanevds(ArtePointer<RTRA> rtra) ;
  
  // Returns the number of pc/mc/tc planes traversd by rtra.
  unsigned int nplanepc(ArtePointer<RTRA> rtra) ;
  unsigned int nplanemc(ArtePointer<RTRA> rtra) ;
  unsigned int nplanetc(ArtePointer<RTRA> rtra) ;

  // Returns the number of trversed pc/mc/tc planes with close hit.
  unsigned int nhitplanepc(ArtePointer<RTRA> rtra) ;
  unsigned int nhitplanemc(ArtePointer<RTRA> rtra) ;
  unsigned int nhitplanetc(ArtePointer<RTRA> rtra) ;
} ;

#endif
