
// *****************************************************************************
//
// source:    rcClassSLT.C
//
// type:      source code
//
// created:   20 Jul 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassSLT
//
// called by: rcClassify
//
// purpose:   classification according to SLT record
//
// hints:     return value rc = 0     nothing classified
//
// changes:
// 20 Jul 2000 (AG) creation
// 20 Jul 2000 (BP) introduced SLT functions 
// 26 Jul 2000 (AG) moved code to rcSelectSLT
// 27 Jul 2000 (AG) introduced SLTEEB
// 16 Aug 2000 (AG) polished code
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "farm/farm.hh"

// externals
extern int FADEB;

// prototypes
int rcSelectSLT();

//
// function code
//
int
rcClassSLT()
{
  ARTE_mark( "rcClassSLT 0", 0 );
  
  int rc = rcSelectSLT();
  
  if( FADEB ) cout << "CLASS: SLT=0x" << hex << rc << dec << endl;

  ARTE_mark( "rcClassSLT 1", 0 );
  return rc;
}
