// *********************************************************************
//
//  Routine:      rcSetError
//  Author:       T.Oest
//
//  Description:  set the error flag
//
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rcflags.hh"
#include "reco/rcerrorflag.h"


unsigned int errmask;

//*****************************************************************
// function
//*****************************************************************

unsigned int rcSetError(char * module) {

  int len = strlen(module);
  char * Cmodule;
  Cmodule   = (char *) malloc(len+1);
  Cmodule[len] = 0;

  if(len>0) for(int i=0; i<len; i++) Cmodule[i] = toupper(module[i]);

//==================================================================
//  initialization
///==================================================================

  unsigned int errorUpdate = 0;


  if (!strncmp(Cmodule,"INIT" ,4)){

   errmask = 0;

   if (recoVDS  != 3) errorUpdate |=  RECO_RSEG_VDS;
   if (recoITR  != 3) errorUpdate |=  RECO_RSEG_ITR;
   if (recoOTR  != 3) errorUpdate |=  RECO_RSEG_OTR;
   if (recoECAL != 3) errorUpdate |=  RECO_RCCL;

   if (rcSelectTracksStatus != 2 || rcrefit == 0) 
                      errorUpdate |=  RECO_RTRA_CHRG;
   if (rcSelectTracksStatus != 2) 
                      errorUpdate |=  RECO_RTRA_NEUT;

   if (recoECAL != 3 || recoPidECAL == 0) 
                      errorUpdate |=  RECO_PID_ECAL;
   if (recoPidMUON == 0) 
                      errorUpdate |=  RECO_PID_MUON;
   if (recoRICH == 0 || recoPidRICH == 0) 
                      errorUpdate |=  RECO_PID_RICH;
   if (recoTRD  == 0 || recoPidTRD  == 0)
                      errorUpdate |=  RECO_PID_TRD;

  };


//==================================================================
//
//==================================================================


  if (!strncmp(Cmodule,"RSEG_VDS" ,8)) errorUpdate |=  RECO_RSEG_VDS;
  if (!strncmp(Cmodule,"RSEG_SVD" ,8)) errorUpdate |=  RECO_RSEG_VDS;
  if (!strncmp(Cmodule,"RSEG_OTR" ,8)) errorUpdate |=  RECO_RSEG_OTR;
  if (!strncmp(Cmodule,"RSEG_ITR" ,8)) errorUpdate |=  RECO_RSEG_ITR;
  if (!strncmp(Cmodule,"RCCL"     ,4)) errorUpdate |=  RECO_RCCL;

  if (!strncmp(Cmodule,"RTRA_CHRG",9)) errorUpdate |=  RECO_RTRA_CHRG;
  if (!strncmp(Cmodule,"RTRA_NEUT",9)) errorUpdate |=  RECO_RTRA_NEUT;

  if (!strncmp(Cmodule,"PID_ECAL" ,8)) errorUpdate |=  RECO_PID_ECAL;
  if (!strncmp(Cmodule,"PID_MUON" ,8)) errorUpdate |=  RECO_PID_MUON;
  if (!strncmp(Cmodule,"PID_RICH" ,8)) errorUpdate |=  RECO_PID_RICH;
  if (!strncmp(Cmodule,"PID_TRD"  ,7)) errorUpdate |=  RECO_PID_TRD;

  if (!strncmp(Cmodule,"RVER_MAIN",9)) errorUpdate |=  RECO_RVER_MAIN;
  if (!strncmp(Cmodule,"RVER_K0S" ,8)) errorUpdate |=  RECO_RVER_K0S;


 errmask    |= errorUpdate;

 free(Cmodule);

 return errorUpdate;

};

//*****************************************************************
// function to return error flag
//*****************************************************************

unsigned int recoErrorFlag() {

 return errmask;

};

