//--*-C++-*--
#ifndef _RINGSEARCHREFIT_H_
#define _RINGSEARCHREFIT_H_
#include "arte/arte.hh"
#include "TMinuit.h"
#include "CLHEP/Matrix/SymMatrix.h"
#include "CLHEP/Matrix/Vector.h"


/// radius ROI in sigmas
const double cutSigma = 8.;
const double  n0T     = 1.3e4;
const double  a16     = 2.44e-6;
const double  a4      = 4*a16;
const double sigma16  = 0.5e-3;
const double sigma4   = 0.5e-3;
const double pi_fact  = 15.7496; // (2*PI)^(3/2)


/** Refit of rings stored in RSEG bank */
class RingSearchRefit {

 public:
  RingSearchRefit();
  ~RingSearchRefit();
  int MinuitRefit();
  int     calcring();

private:

  // -- sigmas
  float   maxSigma2;
  float   maxSigma;
  float   sigma;

  // -- rich
  ArtePointer<RSEG> rich_rseg;
  int     get_hits();
  void    replace_old();

  // -- fit
  TMinuit  *gMinuit;
  double   X0, X0_err; 
  double   Y0, Y0_err;
  double   R0, R0_err;
  double   BG, BG_err; 
  double  SGM, SGM_err; 
  float   CVF[15]; 
};

#endif
