#include "dq/DQ.h"
#include "dq/DQ_RICH.h"
#include "rhp.h"
#include <stdio.h>
#include <math.h> 
#ifndef M_PI
#define M_PI           3.14159265358979323846  /* pi */  
#endif
int riterdq_=0;

extern "C"  void riter_evnt_();
extern "C"  void Riter_init_(){ return;  };
extern "C"  void Riter_evnt_(){ riter_evnt_(); };
extern "C"  void Riter_stop_(){ return;  };

extern "C"  void switch_rich_histos_( int &iswitch );

extern "C" void rhfill_(int &hid,float &x, float &y, float &wt){
  rhp_hfill(DQ_ID(COMP_RICH, LVL_REC, hid ),x,y,wt);
  return;
}

inline void rhbook1(int id, char * name, int nch, float xmin, float xmax ){
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, id),name,nch,xmin,xmax);
}

inline void rhbook2(int id, char * name, int nch, float xmin, float xmax,int nchy, float ymin, float ymax ){
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, id),name,nch,xmin,xmax,nchy,ymin,ymax);
}

extern "C" void dq_rich_switch_riter_(int &iswitch){
  iswitch = riterdq_;
  return;
}

int RITERhbook(){

  /// cherenkov angles
  float min=0;
  float max=0.07;
  int   bin=200;
  /// log(p)
  float lpmin=1.;
  float lpmax=4.5;
    

  rhbook1(1001, "RICH: ntra", 200,0.,200.);
  rhbook1(1002, "RICH: ntra-reco", 200,0.,200.);
  rhbook1(1003, "RICH: nfot", 1000,0.,10000.);
  rhbook1(1004, "RICH: nt (size of iteration table)", 1000,0.,100000.);
    
  rhbook1(1005,	"RICH: momentum",100,0.,100.);
  rhbook1(1006,	"RICH: PID (max prob)", 10 ,-0.5 , 9.5);

  rhbook1(1007,	"RICH: thc, iter, p.gt.15"   , bin,min,max );
  rhbook1(1008,	"RICH: thc, wt=1, p.gt.15"   , bin,min,max );
  rhbook1(1009,	"RICH: ns3/eta, p.gt.15"    ,50, -0.5, 49.5 );

  rhbook2(1010, "RICH: thc-thc([p]) vs. log(p), iter",20,lpmin,lpmax,100,-25.e-3,25.e-3);
  rhbook2(1011, "RICH: thc-thc([p]) vs. log(p), wt=1",20,lpmin,lpmax,100,-25.e-3,25.e-3);
  rhbook2(1012, "RICH: ns3/eta vs. log(p)",20,lpmin,lpmax, 40,-0.5,39.5);

  rhbook2(1013, "RICH: thc vs fic,  p.gt.15, -x up",50,-M_PI,M_PI,bin,min,max);
  rhbook2(1014, "RICH: thc vs fic,  p.gt.15, +x up",50,-M_PI,M_PI,bin,min,max);
  rhbook2(1015, "RICH: thc vs fic,  p.gt.15, -x dn",50,-M_PI,M_PI,bin,min,max);
  rhbook2(1016, "RICH: thc vs fic,  p.gt.15, +x dn",50,-M_PI,M_PI,bin,min,max); 

  rhbook2(1017, "RICH: PID bgr,e,mu,pi,K,p vs. log(p)", 20,lpmin,lpmax,6,0.,6.);
  rhbook1(1018, "RICH: rtra->flr/allrtra", 100,0.,1.);
  rhbook2(1019, "RICH: log(lrk)-log(lrpi) vs p", 50,0.,100., 50,-100.,100.);

  char hbookname[80];
  for (int k=0;k<10;k++){
    sprintf(hbookname,"RICH: thc vs fic pbin=%d",k);
    rhbook2(1021+k,hbookname,30,-M_PI,M_PI,100,-25.e-3,25.e-3); 
  }

  rhbook2(1040, "RICH: Track error (tx) vs. log(p)", 20,1.,4.,100,0.,.01);
  rhbook2(1041, "RICH: Track error (ty) vs. log(p)", 20,1.,4.,100,0.,.01);

  riterdq_ = 1;
  return 0;
};








