//
// Some startup procedures which have to be executed once in the beginning
// of an ARTE job. This was previously part of SvdEvt().
//
// T. Glebe, September 1999
//

// some Arte stuff
#include "arte/arte.hh"
// #include "farm/farm.hh"
// #include "silarte/silarte.hh"
#include "silarte/EVinfo.hh"

// return codes
#include "grr.h"

// sparse event definition
// #include "event.h"
// #include "etb.h"

// prototype declarations
#include "aframelib.h"
// #include "vdsleda.h"
#include "silraw.h"
#include "marvin.h"
// #include "vdsrhp.h"

int SvdStartup() {

  // protection against multiple calls
  static bool firsttime = true;

  if(!firsttime)
    return GRR_OK;
  else
    firsttime = false;

  //
  // No SVD Digitization in case of MC
  //
  if ( CheckMC() )
    return GRR_OK;

  //
  // REAL DATA
  //

  //  const char *routine = "SvdStartup";

  //  LEDA initialization is now done in a special ../arte routine
  //  name: ???

  //  int rc = vdsleda_initprogram();
  //  if ( rc != GRR_OK )
  //    return rc;

  // start silraw
  int rc = silraw_startprogram();
  if ( rc != GRR_OK )
    return rc;

  // start marvin
  marvin_init();

#ifdef XXX
  // vdsrhp init
  rc = vdsrhp_init();
  if ( rc != GRR_OK )
    return rc;
#endif

  return GRR_OK;

}
