// MODIFICATIONS
//
// 09.04.01 - added int  silarte_updateGEDEeff() (fg sciacca)
// 15.05.01 - added declaration of VDSeff_struct, int
//	      silarte_masking() and two definitions (fg sciacca)
// 02.07.01 - added int fillHITBfromSPARSEVTmask() (fg sciacca)

#ifndef SILARTE_HH
#define SILARTE_HH

#define MAXPLANES 128
#define MAXCHIP 10

class GEDE_class;
class HOLMES_class;

#ifdef __cplusplus
extern "C" {
#endif

/* include iol */
#include "iol.h"

typedef struct {
  IOL_MNAME  module[IOL_MLEN];       /* The module name must be first        */
  IOL_SIZE   size            ;       /* The number of verbs must be second   */
  IOL_STRING version         ;       /* version of this package              */
  IOL_FLOAT  hit_resolution  ;       /* hit resolution                       */
  IOL_FLOAT  efficiency      ;       /* average hit efficiency (for MC gen.) */
  IOL_FLOAT  double_hit_resolution;  /* double hit resolution  (for MC gen.) */
  IOL_FLOAT  noise_rate      ;       /* rate of noise hits     (for MC gen.) */
  IOL_FLAG   debug_mode      ;       /* debug mode                           */
} Silarte_Iol_t;
extern Silarte_Iol_t silarte_iol;

typedef struct {
   int usid;
   float eff;
   float chipeff0;
   float chipeff1; 
   float chipeff2;
   float chipeff3;   
   float chipeff4;
   float chipeff5;
   float chipeff6;
   float chipeff7;
   float chipeff8;
   float chipeff9; 
} VDSeff_struct;
//extern VDSeff_struct VDSefficiency[MAXPLANES];

typedef struct {
   int usid;
   int sideid;
   char *chipstat0;
   char *chipstat1; 
   char *chipstat2;
   char *chipstat3;   
   char *chipstat4;
   char *chipstat5;
   char *chipstat6;
   char *chipstat7;
   char *chipstat8;
   char *chipstat9;   
} VDSchipmask_struct;
//VDSchipmask_struct VDSchipmask[MAXPLANES];
//extern VDSchipmask_struct *VDSchipmask_struct_ptr;
//VDSchipmask_struct VDSchipmask[MAXPLANES];
//VDSchipmask_struct *VDSchipmask_struct_ptr;

/* define maximum allowed number of
clusters */
#define DIM_NCLMX   1000


/* Subroutine templates */
int silarte_param_init();


/* sparsification for orte */
int sparseDSVDinit();
int sparseDSVD( int* src_recid,  char *srcdat,
		int* dest_recid, char *destdat, int srclength );
int sparseDSVDstop();


#ifdef __cplusplus
	   }
#endif

/* C++ subroutine templates */
int  fillHITBfromMIMP();
int  fillHITBfromSPARSEVT();
int  fillHITBfromSPARSEVTmask();
int  fillSPARSEVTfromHITB();
int  fillSPARSEVTfromDSVD();
int  fillSILRAWfromDSVD();
int  silarte_updateGEDE();
int  silarte_returnGEDE( char* slname, int lay, int sec );
int  silarte_updateGEDEeff();
int  silarte_masking(char* chips);

/* user calls from ARTE */
int  SvdInit();
int  SvdEvnt();
int  SvdStop();

/* initialization */
int  SvdIolInit();

/* user call to holmes */
int         HolmesInit();
int         HolmesEvent();
int         HolmesGetTargets( float *xtarget[], float *ytarget[], float *ztarget[] );
void        HolmesFillHITBfromARTE( HOLMES_class *HOLMESp );
GEDE_class *HolmesFillGEDEfromARTE();

/* user calls to alignment code */
int  SvdAlignEvent();
int  SvdDoAlign();
int  SvdAlignStop();

/* user calls to efficiency code */
int  SvdEffEvent();
int  SvdEffStop();

/* connection to VDS database */
int silarte_store_VDS_Side ( int major, int minor, int flag );
int silarte_update_VDS_Side( int major, int minor, int flag );
int fillVDSSidefromGEDE    ( int major, int minor, int flag );

#endif
