// *****************************************************************************
//
// source:    kasltsim.C
//
// type:      source code
//
// created:   16 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   treat KUIP commands for sltsim from sltarte
//
// changes:   
//
// 03-aug-2001 (BP) Changed default SLT executable to summer 2000
//
// *****************************************************************************
// standard includes
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

// Arte includes
#include "farm/farm.hh"
#include "sltarte/kasltsim.hh"

extern "C"
{
  char* ku_gets();
  void kugeti_(int *);
}

kasltsim* kasltsim::m_instance = 0;

kasltsim* kasltsim::Instance()
{
  if (m_instance == 0) {
    m_instance = new kasltsim();
  }
  return m_instance;
}

kasltsim::kasltsim():
 m_edcpath("/afs/desy.de/group/hera-b/SLT/Rev0603/Linux_intel_glibc/bin/"),
 m_edcfile("sltsim2000"),
 m_debuglevel(0),
 m_runnumber()
{};


extern "C"
void slt_sim_path()
{
  ARTE_mark( "slt_sim_path 0", 0);

  // read in path
  char *path=(char*) malloc(255);
  strncpy(path, ku_gets(),254);

  if (path[strlen(path)-1] != '/') 
    path = strcat(path,"/");

  kasltsim::set_edcpath(path);

  ARTE_mark( "slt_sim_path 1", 0);
}

extern "C"
void slt_sim_file()
{
  ARTE_mark( "slt_sim_file 0", 0);

  // read in file
  char *file = new char[255];
  strncpy(file, ku_gets(),255);
  kasltsim::set_edcfile(file);

  ARTE_mark( "slt_sim_file 1", 0);
}
extern "C"
void slt_sim_runnumber()
{
  ARTE_mark( "slt_sim_runnumber 0", 0);

  // read in runnumber 
  int arg;
  kugeti_(&arg);
  kasltsim::set_runnumber(arg);

  ARTE_mark( "slt_sim_runnumber 1", 0);
}

extern "C"
void slt_sim_debuglevel()
{
  ARTE_mark( "slt_sim_debuglevel 0", 0);

  // read in debuglevel  
  int arg;
  kugeti_(&arg);
  kasltsim::set_debuglevel(arg);

  ARTE_mark( "slt_sim_debuglevel 1", 0);
}
