
// *****************************************************************************
//
// source:    sltfill.C
//
// type:      source code
//
// created:   24 Nov 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Department of Physics
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    sltfill_
//
// called by: KUIP
//
// purpose:   steering by KUIP
//
// hints:
//
// changes:
// 24 Nov 2000 (AG) creation
// 27 Nov 2000 (AG) moved KUIP initializer to SLTFillArteBanks.C
//
// *****************************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

// ONLINE includes

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// globals
int SLT_FILL = 0;

// externals
extern int FADEB;

// prototypes
extern "C" void kugetc_( char*, int *, int );

//
// function code
//
extern "C" void
sltfill_()
{
  ARTE_mark( "sltfill 0", 0 );

  //
  // read in status
  //
  int len  = 0;
  int len1 = 3;
  char input[7];
  memset( input, '\0', 7 );
  kugetc_( input, &len, len1 );
  input[len] = '\0';
  char *status  = (char *) malloc( len+1 );
  memset( status, '\0', len+1 );
  strncpy( status, input, len );
  if( len>0 ) for( int i=0; i<len; i++ ) status[i] = toupper( status[i] );
  if( strcmp( status, "ON"  ) &&
      strcmp( status, "OFF" )    ){
    cout << "SLT/FILL: status=" << status << " UNKOWN!" << endl;
    return;
  }

  //
  // print
  //
  cout << "SLT/FILL " << " " << status << endl;
  
  //
  // set flags
  //

  if( !strcmp( status, "ON" ) ){
    SLT_FILL = 1;
  }

  if( !strcmp( status, "OFF" ) ){
    SLT_FILL = 0;
  }
  
  ARTE_mark( "sltfill  1", 0 );
  return;
}
