*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTMERG(ch2cut,flag)
c
c       input:    ch2vv    chi**2-cut for merging   R*8
c                          (NDF=3 ---> use 6 ... 10)
c
c       output:   flag (<0 if fail)                 Int
c
c       action:   loop over all vertex pairs and merge if
c                 compatible within user defined cut ch2vv
c
c-------------------------------------------------------------
c
      subroutine  VTMERG(ch2cut,flag)

      implicit none

      double precision 
     1  ch2cut
      integer flag

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"

      integer iv1, iv2
      integer i,j,flag1,it
      double precision 
     1  ch2min, dv

      double precision 
     1  VTDVV

  100 continue
      ch2min = 100.*ch2cut+1.
      do  i = 1, nvt
        if (vtset(i)) then
          do  j = i+1, nvt
            if (vtset(j)) then
              dv = VTDVV(i,j)
              if (dv.lt.ch2min) then
                ch2min=dv
                iv1 = i
                iv2 = j
              endif
            endif
          enddo
        endif
      enddo
      if ( ch2min .lt.ch2cut ) then
        if (ntr(iv2).gt.ntr(iv1)) then
          i   = iv1
          iv1 = iv2
          iv2 = i
        endif
        fit(iv1)=0
        do  i = 1, ntr(iv2)
          it = ktr(iv2,i)
          call VTADD(iv1,it,flag1)
          if (flag1.ne.0) flag=-1
        enddo
        call VTFIT(iv1,0,flag1)
        if (flag1.ne.0) goto 999
        call VTDEL(iv2,flag1)
        if (flag1.eq.0) then
          goto 100
        else
          goto 999
        endif
      endif

      flag = 0

      return

  999 continue

      flag = -1

      return
      end
